
This changelog file only registers (part of) changes to the server programs. The complete
log is accessible from SVN repository at http://sourcesup.cru.fr/projects/wimsdev/

Author abbreviations:
BPR	= Bernadette Perrin-Riou
ER	= Eric Reyssat
FG	= Fabrice Guerimand
GK	= Georges Khaznadar
GX	= Gang Xiao (default author before 3.64)
JE	= Joke Evers
JY	= Joachim Yameogo
MC	= Marina Cazzola
OB  = Olivier Bado
RM	= Régine Mangeard

---------------------------------------------------------------------------
wims.4.07c [r7975]
2014-06-17:
  - the link "next exercise" and "previous exercise" in the sheet appear now
   after the answer is given (at the end of the series if there is a series).
  - correct bug in open classes (files .require was not always good)
  - only score indicators used in the formula appear in the student side.
  - new slib for chemistry: cram, leftind
  - modifications in the presentation of sheets - doc - vote - exam, exercises in sheets
  colors can be choosen by the teacher
  - cdt does not appear if there is nothing inside.
  - java -> jsxgraph in the tool coordclick (J. Lyotard)
  - rawdata are seen by the student - IP are not shwown if the user is "anonymous"
  (example classes in particular).
2014-06-06: [r7865] add chemtool (administrative module).
2014-06-05: [r7860] add chemistry slib creating an svg figure with a Newman
  representation (Yves Noel)
2014-06-02: [r7848] added evaluation functions in libwims (D. Bernardi).
2014-05-31: [r7836] add possibility to choose the colors in the activity presentation
  by the teacher.
2014-05-29: if the expiration date of a sheet is previous than the now date, it
  is changed to the class expiration date when the sheet is activated.
2014-05-26: fix gestion access : could not be added by the administrator
2014-05-04: add the possibility to filter the notes according to some criteria
 given in the user properties - multi conditions are possible.
2014-05-03: add classification module for participative work.
2014-04-14: [r7644] size of the classes are calculated during the daily housekeep
 and write in the file .du in classes.
2014-04-12: [r7637] add !getscorebest for the new indicator.
2014-04-07: [r7612] add a new indicator for the score (mean of the n better scores
  if 10n is the number of required points) as an alternative to
  "cumulative points". Add new formulas using this indicator.

2014-04-07: [r7609] modify exostat.c
  - separate score and noscore (not only from the directory).
  - add possibility to ask stats only for one user or/and one sheet
   (the syntax of the output is different, not quite definitive)
  - add the ten best notes for each exo in case of one or multiple user
  (only if the env user variable is empty).
2014-04-07: [r7602] add !getscorelast and !getscoretry

---------------------------------------------------------------------------
wims.4.07b [r7543]
2014-02-27: add wims_ref_class env variable for !formradio, !formcheckbox, !formmenubar
   (already there for !href )
2014-02: put the form in css instead of table
2014-01: - add option --mathjax , --shtooka, --modules to compile
  - add scripts for mathjax (JE);
2014-01: test the mail in compile
2014-01-03: Can download the two indicators for exercises of a sheet
  (variable sheetexo[number of the sheet])

  - add keywords in domain
2014-01-03: Improve matrix anstype:- add split options for matrix
  - add color in false coefficients
  - add variable result$i as a mask for good and bad coefficients
  In oef exercises, reply_$i is now accessible;; contains the student answer eventually reformated
  as it appears in embed case or in the analysis of the question.
2014-01-01
 in oef exo : give the possibility to impose the order of the exercises in a series
  (the interface was not there).
2013-12-30: delete the link reference
2013-12-28 MathML:adding stretchy="true" to delimiters LEFT/RIGHT triggered by \left \right (JE)
  delete the link reference. Should be put again if work is done on data
2013-12-27:add zones K1, K2 K3 ; add category physical_education
2013-12-26:modify OEF in a sheet now not display in a popup windows
2013-12-26: MathML: Fixing MathJax inputfield bug by using a pre-styled 'textarea' instead of a 'input'
2013-12-23:can add draw feedback in the coord anstype
2013-12-23: Mathml:
  - added environment \begin{html}...\end{html}
  - corrected environment \begin{svg}
  - introduce replace_str() function
  - using correct semantics for pseudo latex \input
2013-12-15: add possibility to use the technical variables in the motd
  (call it by \var_xxx if the variable is xxx as in the liaison tableur - in internal it is user__xxx.
2013-12-14: add the option goodanswershown to coord anstype
2013-12-08: the number of the sheet will no more appear when one uses sequences.
2013-12-04: allows to modify some fields in the insertion of an exo in a sheet when
  it is active: description, title, comments, feedback
2013-12-04: add variable doclist and common_images in var.proc
2013-12-03: fix binomialinv : exact formula when q=p=0.5,
 else use octave (no result in the first example before).
2013-12-03: when inserting a public document in a class, it is now possible
 to link it with some sheet.
2013-12-03: use src2def in latex2wims module
2013-12-03: add primitive audio in documents
2013-12-03: button compile only if srctex is working
2013-12-04:
  Allows to modify some fields in the insertion of an exo in a sheet when
  it is active: description, title, comments, feedback
  Allow to link a public document with a class sheet
  Improvment documents : - latex2wims is now launched by src2def (docu/mkindex)
  - deposit in doc/srctex
  - common_files
  - can have the translation in the same module

new WIMSChem (JE) : svg version
---------------------------------------------------------------------------
wims.4.07a [r7068]
  add anstype time
  add anstype complex
  clean public_html/bases/dic (regenerate files)
  fix warnings in compilation
  fix bugs in search engine
  recover some links lost in theme for student account, change password
---------------------------------------------------------------------------
wims.4.06 [r7010]
 add example classes from Chantal Causse
 work on example sheets
 improvment of the search engine
 add theme pommier (experimental)
 add analysis slib in differential systems
 change the way to insert keywords for autocompletion
---------------------------------------------------------------------------
wims.4.05c
2013-08-07: add possibility to go directly from score of a participant to
the next one (also for exam, raw data, etc).
2013-07: add slib for differential equations, inversedomain (in analysis).
---------------------------------------------------------------------------
wims.4.05b [r6700]
2013-06: add three example classes.
  improve latex2wims (change tooltip in jQuery menu)
  fix some trouble in search engine (in case of several word groups).
  in documents, a block named doctoc can be exploited as a summary table.
---------------------------------------------------------------------------
wims.4.05a [r6585]
2013-06-14: work on popup tool (french version).
2013-06-12: add slib on differential equations.
2013-03-24: work on search_engine and browse module.
- add class and sheets in the category "all" of search engine.
- clean the domains in browse modules (transfer in bases/sys).
- allows the use of language keywords (keywords_$lang, description_$lang,
  title_$lang, etc).
2013-01: - add validation by w3c-validator in modtool (must be configured by
  the manager).
- add test buttons on modtool to go from mathml to images.
- fix bug: if the sequence has been configured on yes,
  but no sequence has been created, the supervisor will see the notes.
- add language menu in properties of a module (modtool) ;
  add jquery for toggle the language menu.
- many changes for better compatibility with xhtml and html 5
- some css have been added and used in adm modules  as wimscenter, wimsemph, tt, small,
  smaller, bold, wimsborder, wimsnoborder (for tables), clearall, spacer, ...
  cut css in small parts, it will be easier to compare for differents themes
2013-01-08: use yuicompressor-2.4.7.jar to compress css.css
2013-01-01: add anstype jsxgraphcurve (Julien Lyotard).
2012-12-16: increase the number of characters save in sessions.log
2012-12-14: improve useropts page (OB)
2012-12-13: add useropts option for dyslexics.
2012-12-13:  add slib/algebra/partitionconj
2012-11-28: cleaning generated files in the example class and documents in bases - the generation
  is done by bin/mkindex (adapt the script src2def and docu/mkindex to be able to do that)
2012-11-28: clean the generated files in oef/$lang/qcm - they will be generated now by bin/mkindex
2012-11-22 : new jobs in raw as copyclass and getsheetstats,  optimizing getlog job,
  now it can render more than 500 lines of a user log (OB)
2012-11-21: add jquery.min.js in public_html/scripts/js/jquery/jquery.min.js
2012-11-07: in wims_mathml, replace non-unique id="wims_mathml" by a
  unique id (id="wims_mathml.....") (JE)
2012-11: introduce widgets and cut the different actions in small pieces (OB, BPR)
2012-11-06: add !formend command to close a !form
2012-11-05: put Doctype declaration to be compatible with mathml (JE)
2012-11-05: new page for sheet search (OB)
2012-10-24: new prepared model : steps.oef
2012-10-23: add slib/draw/radar
2012-10-21: add category algo in H levels
2012-10-18: add small functionality to scienceprint.c (JE)
2012-10-17: in prepared models, add possibility not to use embraced randitem (for mathematical formulas for example)
2012-10-17: add an example class from Chantal Causse
2012-10-16: Fix bug which limits the option shuffle in some anstype
  (comes with the r2063 - because of default in anstype/checkbox)
2012-10-16: Examcheck can now be accessed by a direct link (cmd=new), not only after displaying
  the entire user list (cmd = reply)
2012-10-16: fix bug in cas authentification (not sensible to case): external_auth will
  be always in lowercase
2012-10-13: add parameter for the width of the arrow in chronology model
2012-10-12: add slib/draw/thermometer, add add slib/draw/meter
2012-10-11: add credits field in prepared models
2012-10-10: add an example class from Chantal Causse
2012-10-03: in modttol, add version of the public module when the same exists in modtool
2012-10-02: change tables in correspond in css (OB)
2012-09-30: add some ipa symbols in keyboard anstype
2012-09-30: fix following bug in exolog : renamed-images had the name of the link,
  so the exercise was not visible  once the session was killed.
2012-09-30: fix bug in csv upload and on external_auth : was erased if login is given
  and if there is not external_auth in a csv file.
2012-09-21: add Nikaia theme (OB)
---------------------------------------------------------------------------
wims.4.04 [r5646]
2012-08-20: add symbolic links for nl, si, es models on english models
directexec becomes a multilanguage module
---------------------------------------------------------------------------
wims.4.03f [r5592]
  correction of bugs in htmlmath with mathml version
  zoom is available in mathml (can be desactivated for particular activities)
---------------------------------------------------------------------------
wims.4.03e [r5543]
2012-07-04: add mathmlmath command - accessible by !mathmlmath [r5542]
2012-07-02: add mathml (JE, BPR) [r5524]
2012-06-24: add css styles for simple/sample tables (wimsborder, wimsnoborder)
2012-06-23: version 0.94 of jsxgraphcore.js, HTML Virtual Keyboard Interface Script - v1.49
2012-06-18: Alert message can be send to user connected by supervisor (FG)
            supervisor can see if participants are connected (FG)
2012-06-15: the creator of a subclass can register another teacher in his class.(bpr)
           the administrator of a level can upload cvs files. (bpr)
---------------------------------------------------------------------------
wims.4.03c [r5393]
2012-06-12: add the "besoin d'aide" in the sheetsource of a document (bpr, idea of C. Causse)
2012-06-12: in a superclass, the creator of a class can give
     a gestion access to another teacher (bpr)
2012-06-12: Add guided mode in vote (MC, bpr)
2012-04-22: Can erase a block of a document [r5266] (bpr)
2012-04-04: Supervisor can see which participants of a class are connected (FG)
2012-04-02: Added graphical interactive interface to add help to a series of a sheet (FG)
2012-02-20: Added small exec utility scienceprint (JE)
2012-03-15: External authentification and identification are implemented.
    Add supervise (and participate) fields in the properties of a participant which can be
    changed by the administrator (case of superclasses).
    Improved navigation in superclass (access right)
    In case of external authentification : in a superclass, the teacher who wants to
    go in another class must ask to its supervisor.
2012-01-22: a vote can be desactivate if there is no votant yet or if there is no content.
    If one save before fill the content, the title is saved (no error message). It is not possible
    to activate if there is no content. (bpr) [r4950]
2012-01-09: add command slib in document. (bpr) [r4910]
2012-01-07: add jsxgraph (javascript); add ggb2jsxgraph slib; add the interface in directexex. (bpr)
2012-01-07: can use ggbBase64 filestring in geogebra3 slib. If showAlgebraView=false, a blank
    ggbBase64 filestring is used (if there is no other ggbBase64). (bpr) [r4895]
2012-01-07: when modifying the source of an OEF exercice in Modtool, the link "testing" goes
    directly to the exercise. (bpr) [r4893]
2011-12-31: some part of the differences are printed when a diff is asked in modtool. (bpr) [r4875]
2011-12-30: Add edit_area javascript (sourceforge.net/projects/editarea) for coloration
    of code in Modtool (bpr) [r4869], tool/directexec (does not work for cn language ?) [r4879]

---------------------------------------------------------------------------
wims.4.03a [r4868]
    Presentation of OEF intro modules, of the home page of a gateway has been improved (OB, FG)
2011-12-27: the help link in sheet can be modified when the sheet is active (do not influence
     notation) (bpr) [r4864]
     improvment in latex2wims (minipage, lstlistings are interpreted) [r4866]
2011-12-17: build the list of css classes.
2011-12-17: build list of modules asking to be trusted (must have the line ask_trusted=yes in the
     module file var.init). This list is showed in the help of the field "trusted_module"
     in manager module (bpr) [r4833].
2011-12-14: add "credits" field in OEF exercises to be inserting at the end of the exercise ;
    add the list of authors who are not the main authors (have made exercises) in an OEF
    module intro  (bpr) [r4810]
2011-12-12: supervisor can disallowed score interruption by participant (FG) [r4808]
2011-11-01: in mboard, messages not yet read are in red (css style wims_forum_item_toread)  (bpr) [r4758]
2011-11-01: - add slib/geo3D/drawtile (draw cubes in 3D)
  - add slib to manipulate blank in oef exercises (replace a blank by a character
  or a character by a blank).
  - add bound option in anstype javacurve. Allow multiple select click in regions
  (analyzed as in anstype coord (option bound))  (bpr)
2011-10-19: add option absolute in the anstype numeric  (bpr)
2011-10-15: mail in forum is send to all teachers of the class in the case of a superclass  (bpr)
2011-10-02: can put the address of a module in the search engine to find it.  (bpr)
2011-09-24: - possibility to add an administrative local module in the menu in a theme
  (must create a file local.phtml in the themes with variable wims_local_menu_items
  as the commun variable wims_menu_items) - only do it for the standard theme.
  - Fix bug with csv when a sheet or an exam were not activated
  - add some template file (manager_msg.phtml.template, motd.phtml.template)  (bpr)
2011-09-: one can go directly to the properties of a student after his inscription by the teacher  (bpr)
2011-09-: fix bug when the list of students is big (userlist, sendmail, photoboard).  (bpr)
2011-09-14: site manager may enter ldap parameters, they will by default in all classes
   fix ldap authentification (more general) and fix its use in superclasses.  (bpr)
2011-09-13: add coordclick tool accessible from createxo  (bpr)
2011-08-28: add anstype multipleclick, chessgame  (bpr)
2011-08-15: help link after an exercise of a sheet can be introduced by the teacher. (bpr)

---------------------------------------------------------------------------
wims.4.02 [r4495]
2011-07-28: improve html menu in documents (BPR).
2011-07- : add terms of service (cgu).

---------------------------------------------------------------------------
wims.4.01g [r4390]
2011-07-13: add href primitive in document and cdt (BPR)
2011-07-08: participants can view list of exercises of a skill (FG)
2011-07-05: increase memory when launching gap in config.c
2011-07-05: change the stat slib according of new octave functions and fix some bugs.
(Sophie Lemaire and BPR) [r4330]
2011-07-03: the names of the authors will be firstname,lastname and will be treated
uniformly according to language; it is also possible to put an email for each authors
(this last possibility is not compatible with wims version < 4.02).

---------------------------------------------------------------------------
wims.4.01f [r4248]
2011-06 : add new jobs in module adm/raw (used in connection with other platforms) (OB)
2011-06-09: modification in votes (in particular add checkbox, display result
    in a table) r[4191] (FG)
2011-06-: slib (BPR)
     - help can be now translated
     - add option url and html in slib drawings
2011-06- in a superclass, a teacher can be a participant in a class and a supervisor
     in another one (BPR)
2011-06: add some models (flashcard, hanging game, crossword, ...) (BPR)
2011-05-15: add variables lastname, firstname, login, lang in oef exercise (BPR)
2011-05-: add some css classes to replace <tt></tt> (BPR)
2011-04-20: add option word nohour nominute to slib/draw/clock (FG)
2011-04-06: add binheight to the applet Plinko [r4033] (BPR)
2011-03-19: security in pari - very crucial [r3902]
    - kill warning in Octave ( >=3.00)
    - update interface with m2 ( > 1.1)
2011-03-18:
   - general clean up in the Makefile and the configure file (Karim Belabas)
   - kill compiler warnings.
   - separate the wrapuid functionnality in 3 scripts : setwrapexec (essential and needed
     for safe operation of external programs), setchroot, setwimsd
   - clean bashism
2011-02-19 : add logout in modtool (BPR) [r3768]

---------------------------------------------------------------------------
wims.4.01e [r3745]
2011-02-14: add linguistics category (BPR) [r3742]
2011-02-12: add prohibited words in forum messages (BPR) [r3732]
2011-02-07: replaced strcpy function in C code to avoid problem on 64 bits machines in case of overlapping strings (ER) [r3717-3718]

---------------------------------------------------------------------------
wims.4.01d [r3707]
2011-01-30: add transfer class document in modtool (BPR) [r3704]
2011-01-30: add transfer from createxo to modtool (BPR) [r3700]
2010-12-05: add html editor to documents (BPR) ([r3618])
2010-12-04: a document block can be embedded in another document (bpr [r3616])
2010-11-25: change preambule for maxima (i is now %i) (bpr)

---------------------------------------------------------------------------
wims.4.01c [r3585]
2010-11-17: delete bin/passcrypt [r3578]
2010-11-10: update tooltip, latex2wims [r3553]
2010-10-16: add small exec utility moneyprint (JE) [r3519]
2010-08-28: add variable instex_texheader (value can be defined in wims module) - add header file for frcursive
([r3416 and others] bpr
2010-08-21: add crossword anstype, crossword slib and crossword program in src/Misc/crossword from the
  jigsaw.c ([r3397] bpr)
2010-06--: add editor for createxo (OB) - integration of the OEF documentation (not finished).

---------------------------------------------------------------------------
wims.4.01a [r3378]
2010-07-18: add puzzle anstype (bpr)
2010-07-18: fix bug in insdraw..processor : datamodule was not interpreted and images in $common_images were
  not found in this repertory when call with copy flydraw command.
2010-07-16: add oef command teximg (gives the address of some tex text, can be used to be copied
in a draw image (bpr).
2010-06-2: fix introduced bugs in modtool (bpr).
2010-06-11: add the variables title_$lang in oef modules. (bpr)
2010-06-11: Variable wims_main_dirn, defining client dir(ection). (ER)

---------------------------------------------------------------------------
wims.4.00 [r3243]
2010-04-19: add css class : wims_button and wims_button_help and introduce it in many adm modules ;
    use it for input[submit] (OB and BPR).
    Added ref_button_color, ref_button_bgcolor, ref_button_help_color, ref_button_help_bgcolor
    (adm/manage and adm/class/config) and vlink_color,link_color (config.c) [around r3076-3079]
2010-04-08: can download and publish from many download center list in bases/sys/publishcenter directory (FG & BPR)
2010-04-04: add slibs for jmol (bpr and Yves Noël) [r2998]
2010-04-02: add jmolclick reply type (bpr and Yves Noël) [r2989]
2010-03-20: can change of exercises series without go to sheet summary (FG)
2010-03-16: add job=sendmail in adm/manage (FG)
2010-03-06: add job=lightpopup in adm/raw ([r2732 and als] FG)
2010-02-24: add language choice in the search_engine ([r2670] bpr)
2010-02-23: OEF exercises: add command \latex{} - if it contains something (tex version of the statement),
  a tex file can be download with the exercises (two latex environments can be used (statement and solution))
   [r2656 | bpr]
2010-02-23:OEF the printable sheet uses now the number of exercises in a serie of OEF exercises.
   [r2656 | bpr]

---------------------------------------------------------------------------
wims.3.65m [r2626] wims.3.65l [r2098] wims.3.65k [r1989]
2010-02-20: add type chemclick based on WIMSchem [r2616 | bpr]
2010-02-19:theme by default become standard theme - change the default color [r2608]
2010-02-19:add notion of maintainer of a module (module variable maintainer and maintainer_adresse),
   can be used in any module and appear in the "about" ([r2607] bpr)
2010-02-16:add anonymity option in best scores [r2581 | ER]
2010-02-: all previously existing language dependent adm modules are replaced by one module
  constructed by localization of these modules, keeping a single computation core and
  adding dictionaries. [essentially bpr with help of translators and als]
2010-01-03: add type jmolclick based on jmol [r2097 | bpr]
2010-01-03: add flash player for video and audio and slib [r2096 | bpr ]
2009-12-28: add wims_ref_menucolor for links in menu (BPR) [r2069]

---------------------------------------------------------------------------
wims.3.65j [r1941] wims.3.65i [r1872] wims.3.65h [r1832] wims.3.65f [r1511] wims.3.65e [r1479] wims.3.65d [r1451]
2009-12-02: add slibs (domino, approximation) - add option noorder in clickfill and dragfill
2009-11-29: add colors in userlist [r1919]
2009-11-17: add sendmail [r1864] (BPR)
2009-11-12: add Véronique Royer Terminale Class (BPR)
2009-10-: improvment in language independancy.
2009-09-20: add photoboard [r1631] (BPR)
2009-09-20: clean userlist.$lang module and change the order of sheets in case where sequences
are used (round [r1627]) (BPR)
2009-09-07: standard theme supervisor read manager message in file log/manager_msg.phtml.$lang.
No interface. (BPR)
2009-09-06: modified units-filter; fixed a bug in the rendering of numbers whose absolute value
is in the interval 0..1; slightly modified the rounding routine to get a smarter behavior
with data whose mantissa should be 0.5 (and are actually messed up by float calculation) (GK)
2000-09-02: improvement of module adm/class/sheet.fr (FG)
2009-09-02: search_engine form files and linked names moved from module home to
script/adm/search_engine for calling by other modules (FG)
2009-08-31: upgraded units-filter to version 3.0. This should fix the bug with wrong truncations.
For example earlier versions rounded the value 2.5 to 2 and not 3 as expected.
Now the analyzer uses the GNU multiprecision library, and calculations are done
with rational multiprecision numbers (GK)
2009-08-23: add flydraw documentation translation in french and prepare for other languages [r1502]
2009-08-22: add description field in class documents (appear only in sequences) [r1499] (BPR)
2009-08-16: participant index is done in all subclasses when indexing is done from portals [r1459] (BPR)
2009-08-05: add speckedit (html editor) (for the moment in in motd and mboard) [r1448] (BPR)
2009-08-05: add doc in helplink in cdt [r1447] (BPR)
2009-07-: add participate in class csv for upload (only for supervisor of gateway) (BPR)
2009-07-: add module "adddoc" to insert documents in a class (BPR)
2009-07-: module "sequence" to reorganize sheets, exams, documents ....(BPR)

---------------------------------------------------------------------------
wims.3.65c [r1377]
2009-06-30: add module livret for view notes in competence table (FG)
2009-06-28:add in class config the possibility to give a link on another platform which will appear in
   the class homepage - only in standard theme [r1288] (BPR)
2009-06-01:add option word in class config to show sheet weights in user page home [r1209] (BPR)
2009-05-21: add mhelptail.phtml [r1175] (BPR)
2009-04-24: OEF accepts \css (allows to introduce a css style) [r1104] (BPR)
2009-04-20: cleanup of html codes - add label in some forms (modtool, inscription, class creation) (BPR)
2009-04-19: add !header1 (as !header but without title) [r1050] (BPR)
2009-04-16: Flydraw update : add vectorial graphics file output (DXF), new command vimg, vimgfile ;
   add also double arrows (arrow2) [r1024] (GX)
2009-04-05: add js for keyboard, html editor [r1012] (BPR)
2009-04-05: add german collection from shtooka projects (math voc and numbers) [r1011] (BPR)
2009-03-  : add "embeddable player" inserted in the "about module" [r973] (OB)
2009-03-17: add clicktile answer type [r983] (BPR)
2009-03-04: add rss link in news module [r970] (BPR)
2009-03-04: add german verbs collection from shtooka projects [r969] (BPR)
2009-02-28: add clicktile applet of Joke Evers [r968] (BPR)
2009-02-28: add mail to supervisor for new forum messages [r967] (BPR)
2009-02-27: fix internal server error on ubuntu (BPR) [r964]

---------------------------------------------------------------------------
wims.3.65b [r940] wims.3.65a [r940]
2009-01-25: add zirkel applet. (BPR) [r940]
2009-01-25: add photourl variable in userlist. (BPR) [r938-937]
2009-01-04: add chemistry program for analysing molfile. (BPR) [r913]
2009-01-01: add chemistry applet modified by Joke Evers (initially SketchEl) (JE) [r903]
2009-01-01: use mail_opt everywhere mail is send by wims (BPR) [r901]
2008-12-31: make changes in data/swac - should be more stable (BPR) [r900]
2008-12-29: add msg.phtml in oef modules (BPR) [r893]
2008-12-26: fix gnuplot compatibility (BPR) [r892]
2008-12-13: IP adress can be hide by managersite (FG) [r877]
2008-12-07: fix some bugs in exercise printed version(BPR) [r874]
2008-12-05: improvment in document (BPR) [r871] and [r]
2008-12-04: few bugs corrected on module adm/raw (OB) [r870]
2008-11-25: supervisor can add personnal user daymessage (FG) [r863] and following
2008-11-07: add possibility to change the modtool account in a class (BPR) [r849]
2008-10-05: fix "bashism" in bin/wrapuid and bin/apache-config (BPR) [r824] and in compile [r825]
2008-10-02: fix anstype/geogebra [r822] and anstype/sigunits (BPR) [r821]

---------------------------------------------------------------------------
wims.3.64 [r798]
2008-08-26 and before: many improvments of authordir jm.evers (JK)
2008-08-26:add slib for phonetics (BPR) [r791]
2008-08-23: improvment in geogebra type. (BPR) [r776]
2008-08-11: Add command tooltip in document - improve the special method in oef (BPR) [r756-r757]
2008-08-10:scripts/oef/togetfile.proc is trusted file for adm/doc as it
     is already for createxo (fix a submitted bug) (BPR) [r749]
2008-08-08: adm/doc.* : make some phtml files language independant (BPR)
2008-08-:latex2wims - add tabular type environment and fix minor bugs (BPR)

---------------------------------------------------------------------------
wims.3.63d [r720]
2008-06-30: add thermo sheets (J-R Vacher)

---------------------------------------------------------------------------
wims.3.63c [r677]
2008-06-xx: big improvment in Dutch, Italian and Catalan version.
2008-06-18: add interface to ldap authentification in a class (BPR for interface +
C. Lefèvre) [r633]
2008-06-18: delete adm/scenario.* adm/dialog.* - they have been transferred in
     scripts/scenario scripts/dialog (see docu and oef) - allow publication of the modules
     using them [r623], [r624] (BPR)
2008-06-16: add possibility to hide exam registrations to students. [r603] (BPR)
2008-06-14: may download style css in class [r565] (BPR)
2008-06-14: change place of photos and basis of the puzzle modules to scripts/data/
    - the modules H3/algebra/spuzzle.$lang and  U2/algebra/qpuzzle.$langwill will
    be added in the Nice publication center at next release. [r563] (BPR)
2008-06-13: add Imindex in oef modules (for ulterior testing if a file is in \imagedir)
     [r561] (BPR)
2008-06-08: add new fields title_$lang description_$lang translation_language for modules
     who have their language translation insid them (don't yet accessible by the Modtool
     interface) [r554] (BPR)
2008-06-08: add option in embed of "input type" (autocompletion=off, css style for
    the input box [r521] (BPR)
2008-06-08: add eqsign option in equation [r518] (RM)
2008-06-08: add sheets for level U3 [r519] (BPR)
2008-05-27: Add exemple class : 1118 Première STG (RM)
2008-05-27: Add exemple class : 1117 Première STI (RM)
2008-05-27: Add exemple class : 1116 Première S (RM)

---------------------------------------------------------------------------
wims.3.63b [r468]
2008-05-25: add scripts for indexing shtooka directories (words audio http://shtooka.net/project)
      [r451] (BPR)
2008-05-24: add style css documentation in bases ; fix bug in management : css stylesheet in home/css
      doesn't appear in list (BPR)
2008-05-04: improvment in the adm module new : use the title in user language
      if it is defined in the INDEX module (for JE modules in particular) [r392] (BPR)
2008-05-??: improvment in adm/raw (OB)
2008-04-28: add catalan version (from Manel Querol)
2008-04-07: add data/scripts in the list of directories where the command
      rename may be used [r382] (BPR)
2008-04-07: add english example class [r379-380] (BPR)
2008-02-17: fix in formal type (in case of nonanalysed answer) (BPR-ER)
2008-01-12: manage.en bug correcting, add class search engine and bestclass general activity showing [r282] (FG)
2008-01-08: Improved chemistry slib [r281] (GK)

-------------------------------------------------------------------------
wims.3.63a [r256]
2007-12-30: Add geogebra3 [r252] (BPR)
2007-12-30: Add css style in sheet : wims_sheet wims_sheet_list for exercise list in sheet [r251](BPR)
2007-12-27: Tex is now forced by \displaystyle  inside \( ) [r242] (BPR)
2007-12-26: Fixed bug in mboard.fr ; add list by subject, improved navigation, add
        css style (wims_forum_intro, wims_forum_msg, wims_forum_list) ; language in fr/ [r237] (BPR)
2007-12-25: add adm module : class/activity (BPR)
2007-12-15: del unused link on supervisor page for class groupement (class_type=2) (FG)
2007-12-15: module cdt.fr and cdt.en add exam to linklist (FG)
2007-12-14: superclass_quota replace class_quota for portal structure (FG)
2007-12-08: add to votes (french version) "traced vote" ; add csv upload of votes results.
        [r217] (BPR)
2007-12-03: give to sc_reply the same status as reply. Can be used in test conditions.
        [r213] (BPR)
2007-12-03: Add option "noreaccent" in answer type case [r209] (BPR)
2007-11-28: Fixed bug in votes [r203] (BPR)
2007-11-25: Fixed bug: login with point was accepted but data was erased
        by csv upload [r202] (BPR)
2007-11-23: Fixed bug: presentation sheet with doc page (all lang) (FG)
2007-11-21: Add an option parameter for answer : noanalyzeprint : in this case, no
        preformatted analyzed answer is printed (only the score). (BPR)
2007-11-20: Some oef help translations in script/help in separate directories (for the moment,
        fr, es, cn) (BPR)
2007-09-27: Fixed in adm/class/userlist.fr/cvs : email variable was removed when
        uploading cvs, empty variables for participants were replaced by preceeding
        participants when downloading cvs. Added possibility to download or upload
        technical variables. (BPR)
For the moment, only in french version. (BPR)
2007-09-25: patch on the cn version (from Zhijie Chen, transmitted by GX)
2007-09-16: fixed the anstype scripts for chemeq, units,
            sigunits. Now they allow to see the good replies in debug
            mode with Createxo, and the correct answer is shown when a bad
            reply has been fed in. (GK)
2007-09-16 Add chemistry slib (GK)
2007-08-28 Correction for option keeporder : solution was in first position in type clickfill for option
         keeporder (BPR)
2007-08-27 Add votes in class download (class/config) (BPR)
2007-08-19 Add special method tabs2lines in OEF (in OEF, lines in variables
	       are transformed to tabs after error messages or next step,
	       which is not accepted in some applets). Same as special method expandlines
	       except for the pre tag (BPR)
2007-08-13 Add javascript wz_dragdrop.js  in js/ (BPR)
2007-08-13 Add slib/utilities/tooltip and special method tooltip in OEF (BPR)
2007-08-02 Example class declared as neighbor of all classes (FG)
2007-07-16 Add fonctionalities to exam module creation only fr, en (FG)
2007-07-14 Bug fixed : personalize home and sheet page with document (FG)
2007-07-13 Default configuration for oef options in class (FG)

---------------------------------------------
Version 3.62 packed.
2007-06-23: Updated slib/media/audio : add option rename (BPR).
2007-06-19: From BPR:
	      help is accessible in Modtool as a zone
	      adm/latex2wims.fr new module
	      help/example/oefquicktool.fr new module
	      Add anstype,help,slib as binary directories in adm/modtool.fr/binfile.proc
	      Link on latex2wims.fr  and on quicktool.fr in modules/adm/createxo.fr/level1.phtml
		 and in public_html/modules/adm/modtool.fr/modname.phtml
	      Link on program.fr et faq.fr (french version) in public_html/modules/adm/browse.fr/home.phtml
		 and public_html/modules/adm/class/sheet.fr/main.phtml
	      Option "nonstop" in step exercises
	      New parameter \sc_reply$i in OEF : accessible for feedback with
		 default values  0,1, 0.5 according the student reply is
		 bad, good or partially good
	      public_html/bases/doc/1027 Presentation improvment
	      slib/geo2D/geogebra Improvment (Paul Byache)
	      Improvment in documentation of type range (english version -> french version)
	      js/ASCIIMathML.js js/LaTeXMathML.js js/ASCIIsvg.js new javascript
	      java/jmol/Jmol.js java/jmol/JmolApplet.jar : new Java applet Jmol
	      Improvments in help/developer/docmodtooloef.fr help/developer/docqcm.fr
	      help/teacher/docdocument.fr help/teacher/docexooef.fr help/student/docetud.fr

2007-06-19: From ER:
	************ corrections de bugs ************
	For each bug :   1/ description   2/ changes made   3/ changed files.

	1/ When an exo is introduced in a worksheet, if we erase its description, it
	comes back as non empty (but possible to erase afterwards by modifying sheet)
	2/  use new variable new_desc instead of some occurrences of desc.
	3/  files changed :
	public_html/modules/adm/class/addmodule.[cn,en,es,fr,it,nl,si,tw]/[main.phtml,var.def,var.proc]


	1/  binary files of modtool in subdirectories were counted twice (once in
	dir, once in subdir)
	2/  add a "sort|uniq" to list of binary files
	3/  files changed :
	public_html/modules/adm/modtool.[cn,en,fr,it,nl]/binfile.proc


	1/  good replies were impossible to insert in development mode right after
	modif of source in createxo, except in french version.
	2/  mimic french version by introducing variable oef_defaut in var.def.
	3/  files changed :
	public_html/modules/adm/createxo.[cn,en,es,it,nl,si]/var.def


	1/  the french help for answer type wlist pointed to the english text for
	synonyms
	2/  changed pointer to  help/anstype.fr/syno.phtml
	3/  file changed : public_html/scripts/help/anstype.fr/wlist.phtml

2007-05-12: add class exemple : 1113 (RM)
            add class exemple : 1114 (FG)
	    add link "back to module" in addmodule.fr and addmodule.en
	    add job=showsheet in userlist.fr : control
		board panel for sheet (FG)
2007-05-01: Added new oef answer option "nonstop" (BPR).
2007-04-30: A new French example class 1113 (Regine Mangeard).
	    More French public sheets (FG).
2007-04-19: Updated adm/class/cdt.fr (FG).
2007-04-13: anstype/numeric: fixed a cheating flaw.
2007-04-02: (GK) Improved the slibs graphpaper/*: now you can give
            maximal values instead of the tick increment, and have it
   	    calculated automatically. You can also label the axes.
2007-03-28: J-R Fernandez: important upgrade in the Spanish translation, for
	    the user interface and the base modules.
2007-03-14: Updated to chemeq-1.12.
2007-03-14: (GK) added a new slib to get precise numeric informations
            about the conservation of elements and charges in chemical
	    equations. The results come either as an understandable html
	    table or a ready-to-use matrix. This script need at least
	    the version 1.12 of chemeq. If the version of chemeq is not
	    sufficient, an error message is given instead.
2007-03-13: Updates to Dutch version. (JE)
	    New and updated slib. (BPR)
	    anstype/javacurve.points: added drawing for multiple clicks. (BPR)
2007-02-22: "about.bak" in doc modulesreplaced by "about.phtml". (BPR)
2007-02-14: bin/mkindex and Misc/modind.c: added recognition of datamodules.
2007-01-26: MAX_FILELEN lifted to 2 mega.
2007-01-23: added config parameter mail_opt.
2007-01-14: anstype/checkbox: \\( -> \( for presentation (BPR).
2007-01-12: user_agent checking seems to create problems: stopped.
2007-01-11: adm/vote: Correction d'une incompatibilité entre une limite à 64
		dans le nombre de questions possibles et un traitement à 40
		dans var.proc et var.def (BPR)
	    anstype/checkbox: correction d'un bogue dans
		script/anstype/checkbox (cas de  virgule) et modification
		de la réponse : \\(  devient \( . (BPR)
	    exec.c, exec_for(): strchr(",") -> strparchr(",") (item search
		should skip parentheses).
	    adm/class/userlist/csv/download.proc: manual score downloading was
		broken with a wrong insertion of !hex (BPR).
2007-01-08: symtext: added shared macros.
2007-01-05: symtext package made independent.
	    exec.c, _httpfollow(): mhelp session address was broken when
		invoked from an mhelp of a subsession.
2007-01-02: bases/dic/fr/accord: plurals of exceptional nouns were forgotten.
	    symtext: added pool structure to allow parbitrary permpick nesting.
2006-12-30: More types to anstype "javacurve" (BPR).
	    scripts/oef/embed.phtml: corrige un bogue de couleur dans
		l'affichage du type mark (BPR).
	    scripts/oef/fr: typos de francais + couleur orange pour les
		réponses partiellement bonnes ou avec mauvaise
		précision (BPR).
	    Updated files in slib/text (BPR).
	    java/input.java: added vector style.
2006-12-26: symtext: added debug level.
	    symtext compile error: nextblock field forgotten in some cases.
2006-12-25: symtext: translate.c, entry earlier field offset error.
2006-12-24: symtext: accented letters were isolated in pre-processing.
2006-12-21: check_exam(): now checks the existence of session var file
		instead of session directory existence.
	    symtext: increased dictionary size limits.
2006-12-20: symtext, outval(): typo corrected.
	    adm/class/regclass/var.proc, policy=file: suppressed spurious
		variable definitions (class_creation etc.).
2006-12-14: Included Geogebra applet in java/geogebra. (www.geogebra.org)
	    Anstype/javacurve: added points version. (BPR)
2006-12-13: GK: fixed a very nasty bug with the OEF type sigunits, which
		disregarded the numeric value, focusing only on the unit and the
		number of significative numbers.
	    bin/povray: Added some default values for compatibility (BPR).
2006-12-12: Added slib lang/fraccord.
2006-12-05: Misc/translator.c and Misc/translator_.c: search failed when
		dictionary contains accented letters.
2006-12-04: Fixed in adm/class/userlist/csv/download.proc: manual grades were
		still not correct for usernames with special characters.
2006-12-02: WORKFILE_LIMIT moved from lines.c to wims.c.
	    WORKFILE_LIMIT default increased to 2M (from 512K).
	    Anstype/*fill: added align option (BPR).
2006-11-29: slib/matrix/concate updated (BPR).
2006-11-24: Added new command !hex.
	    adm/class/userlist and adm/class/grades: manual grades for usernames
		with special characters now correctly fixed using !hex.
2006-11-22: webget: added proxy compatibility.
2006-11-21: Updates to Italian version (MC).
2006-11-20: adm/class/userlist/csv/download.proc: erase fields before recomputing
		for a new user.
2006-11-17: Added User-Agent to !mailto header (compatibility with some ISP's).
		All adm module mail interfaces now switched to !mailto.
	    Added mail_log().
2006-11-15: adm/class/userlist: manual grades dysfunction when login contains
		special characters (the solution is still not correct).
2006-11-10: rounding fix of scripts/js/basicalc (FG).
2006-11-08: Fixed in adm/forum/mbord.cn: missing scripts.
2006-11-03: oef: added qcm common manager.
	    oef2wims: No exec if hint/help/solution contains no exec commands.
2006-11-01: adm/modtool: developer name was not put into session var.stat
		when the user is automatically logged in via a class.
2006-10-26: adm/createxo.fr: added 2 models (qtext and 16qtext).
2006-10-23: Added slib oef/env and scripts/oef/datafile.proc
2006-10-22: scripts/oef/mkindex: Added datafile indexing.
2006-10-20: wimslogd, dispatch_log(): suppressed useless error messages.
---------------------------------------------
Version 3.60 packed.
2006-10-17: class/cdt.fr updated to 1.11 (FG).
2006-10-15: Fixed: nesting error in symtex permpick (lind2 incremented
		without decrementing in case of failure).
2006-10-13: Fixed: nested errors provoke "Premature end of script headers".
	    Fixed in adm/modtool: class user developer link was broken due
		to password encryption.
	    anstype/range: default value was set to the left end instead of middle.
		help updated for the case of multiple ranges.
2006-10-09: Fixed in adm/createxo: default author name didn't show up when loaded
		by module developer.
	    update.sh: erase ch..root etc. if need to be written over.
	    calc_lookup(): rights check now uses datafile_check().
2006-10-08: Added typed circuit schematic system: data, slib, drawing tool.
2006-10-04: !filewrite, !fileappend, files with name starting by "TEMP_"
		are temporary files and go to tmp_dir.
	    find_module_file(): files starting with writable/TEMP_ are
		temporarily written files.
	    datafile_recordnum() and datafile_fnd_rec(): save value of "untrust"
		and restore before exiting.
2006-10-02: slib/mkindex: presentation improvement.
	    New categories: H?/financialmath, U?/financialmath, tool/elec
	    datafile_check(): allowed userfiles to read files in subdirectories
		"data/" and "authors/".
2006-10-01: Fixed in flydraw, obj_string(): quoting chars were not stripped.
2006-09-29: Anstype numexp: Message precision (FG).
	    Fixed in flydraw, obj_parallel(), obj_lattice() and obj_arrow():
		displacement vector didn't follow affine transformation.
2006-09-26: adm/class/regclass: removed the word "optional" for class password (FG).
2006-09-25: checkhostt(): tolerate spaces after '<' and '>' (but not before).
	    Italian translation updated to 3.58 (MC).
	    adm/class/userlist: allow csv upload without password in gateway
		subclasses.
2006-09-24: oef: added good choice insertion for developer to choices.
	    oef: added choice option "noidontknow".
2006-09-23: chroot.c: added parsing of w_wims_priv_chroot, with word
		"tmpdir" causing preliminary directory change.
	    c, fortran77, pascal, python interfaces: now compile and run on tmp_dir.
2006-09-22: chroot.c: abort if setuid() fails.
	    scripts/oef/var.proc: check datamodule only when cmd=new.
	    find_module_file(): send module_error for executable files.
2006-09-21: Fixed in scripts/oef/var.proc: step information was not cleared
		from one exercise to another.
	    Fixed in scripts/oef/step.proc: empty data in menu type was
		not checked.
	    adm/class/gateway: added secure hosts to structure management.
	    adm/class/regclass: secure host now defaults to "all".
2006-09-20: bin/housekeep.daily: buggy sheet expiration code disabled, to
		be enabled during a summer vacation.
	    Fixed in scripts/adm/gateway/mkteacherlist: a too strict right
		check skipped index update after a teacher subscription.
	    adm/class/userlist/var.proc.userprop: added call to mkteacherlist
		when the user is supervisable.
	    Fixed for gateways: link for changing user property was missing.
2006-09-19: Fixed in oef2wims, _check_compare(): check of "or" not returned
		after success, going to the check of "and" instead.
2006-09-18: OEF development mode: insertion of good replies becomes non-auto.
	    Anstype dragfill and clickfill: added options "keeporder",
		"sort" and "shuffle".
	    Anstype: added option "sort" to checkbox, menu and radio.
	    adm/class/regclass: added secure host validity check.
	    The variable "empty" is now strictly read-only, with offending
		module adm/modtool fixed.
	    Fixed in oef: javascript form locker was skipped when running under
		createxo.
	    Added option "default" to OEF answers.
	    bin/povray: version call should add ch..root, otherwise it
		may refer to a different installation of povray.
	    instex_flush() (lines.c): suppress "mv" error messages.
2006-09-17: Anstype: activated option "shuffle" for checkbox, menu and radio.
	    Anstype menu: added option "multiple".
	    Anstype: added option "eqweight" to mc types with "split".
	    Anstypes: added developer default to checkbox, menu, radio.
2006-09-16: adm/modtool: edfile now allows file upload.
	    adm/class/gateway.{en,fr}: Added teacher supervising management.
	    Added hierarchical access right check to gateway management jobs.
2006-09-15: Added evaluation of \step to oef help.
	    adm/createxo: exercise help now works.
	    adm/createxo, raw mode: returning from help erased textarea.
		Added textarea content control buttons.
	    subclass expiration date now refers to superclass expiration.
	    Fixed in default and column themes: documents/votes not shown for
		participants in intermediate classes.
	    Fixed in scripts/adm/class/adduser: a bogus password check locked up
		adding class/course subscription in gateway.
	    bin/housekeep.daily: diving to subclasses for daily cleanup.
2006-09-14: Popup session life reduced to 50 seconds.
	    catfile() now returns the number of bytes written.
	    Fixed: empty last.html was provoking "Premature end of script header".
	    Added non-backup and ancient class warnings to adm/class/config.
	    adm/class/config: subclasses can no longer change expiration date.
	    adm/class/userlist: csv download of passwords now allowed.
2006-09-13: scripts/adm/class/adduser: Added check of name conflict between
		teacher and participant accounts.
	    adm/class/gateway: Added csv download of teacher accounts.
	    adm/class/userlist/csv/upload.proc: added call to mkteacherlist
		if superclass.
	    adm/modtool.cn: proc files were missing.
	    adm/modtool, edfile: recovered new line at end of file.
	    Fixed: oef replytype synonyme translation bug.
	    Fixed: oef replyweights stacking up via valsave.
2006-09-12: Updates to adm/class/cdt.fr (FG).
---------------------------------------------
Version 3.58 packed.
2006-09-11: Updates to help/teacher/docdocument.fr (BPR).
	    scripts/oef/mkindex: should erase index files when no oef.
2006-09-09: !writefile to getfile: writing to symlinks and subdirectories
		prohibited.
	    Added !writefile and !appendfile limits.
2006-09-07: Fixed in adm/manage.en: wims_prefix should be cleaned when
		reading wims.conf.
2006-09-06: Added scripts/adm/class/stat.
	    adm/vote/vote.proc: grouped !setdef to improve performance.
	    Default language changed to utf-8 (for undeclared languages).
2006-09-05: Fixed: class modules didn't have variable right management.
	    Fixed in wimslogd: log files with a hyphen in name should not be skipped.
	    files.c, _filewrite(): classes/?? modules should not have right to
		write to wims_home.
	    lines.c: added is_class_module to disallow classes/?? modules to access
	    scripts/adm files and many adm commands.
2006-09-04: Fixed in adm/createxo/var.proc: a typo locked class importation.
	    Fixed in adm/sheet: printable version locked by wims_prefix.
	    Fixed in scripts/adm/class/adduser: individual subscription locked.
	    Light updates to Dutch version (JE).
	    Fixed in adm/class/config: importation of exams didn't work.
2006-09-03: Updates to slibs: text, chemistry, geo3D (BPR).
	    Fixed slib/triplerelation/tabular: infinit loop problem (GK).
	    Added scripts/oef/special/rename.phtml (BPR).
	    Fixed: typos in tool/directexec.fr (BPR).
2006-08-30: Fixed: typo in adm/forum/mboard.??/var.init locking up all forums.
2006-08-28: Fixed in var.c, get_var_privileges(): should unset untrust.
	    Fixed in adm/manage.en: DF should be declared in wims_prefix.
	    Fixed in home module: more wims_readable (FG).
	    adm/class/userlist: csv upload unlocked for gateway.
2006-08-27: scripts/adm/class/adduser: only gateway admin can add teachers.
	    scripts/adm/class/userremain: now takes into account limits of
		parent classes (only for groups where subclasses are subdirectories
		of parent classes).
2006-08-25: Fixed: mark and checkbox anstypes with commas in the text.
	    Added scripts/oef/togetfile.proc (trusted file for createxo).
	    Readability of wims_sesrandom closed to user files from adm modules.
2006-08-24: FG: adm/class/cdt.fr updated (add use of wims_prefix).
	    Included java atomic lattice viewer by Simon Gill (java/Lattice).
	    Fixed: adm/createxo.{en,fr}, model mode could not tolerate data with
		colon at first column.
	    Added/modified slibs: chemistry, geo3D (BPR).
	    Added subdirectory scripts/data (BPR).
	    Fixed in oef: embedded replies have no default type (thanks to BPR).
	    Fixed in createxo: vsavelist should not be put in wims_nw.
		(thanks to BPR).
2006-08-23: Fixed: wims_read_parm should be excluded from access right control.
2006-08-21: scripts/oef/quizzintro.phtml added Italian version (Gianni Ciolli).
2006-08-18: Fixed for home module: popup search locked by variable rights.
	    Link modules/home/tool removed.
	    bin/update changed to version 357.
2006-08-15: adm/createxo (en,fr), model mode: added menu parameters.
2006-08-13: Fixed: adm/createxo.fr, model menutext1.oef, should add
		singlespace to data.
	    Fixed adm/createxo (en,fr), mode=model: should clean reply$i
		when returning from test.
2006-08-09: !writefile and !appendfile: getfile/ becomes special.
2006-08-07: adm/modtool.en, flist.phtml: OEF interface link forgotten.
	    Fixed: some commands setting internal variables not working
		when called by a user file.
2006-08-05: Security adjustment: adm/createxo added wims_trustfile.
		adm/* & home added tmp to wims_prefix.
2006-08-05: Added variable access rights control for user files.
	    Security reinforcement: wims_prefix added to adm modules.
2006-08-03: variables.c: added var_def_check().
	    setvar(): user file has no right to modify wims_ variables.
2006-07-31: Added communication between Modtool and Createxo (modif only).
2006-07-26: adm/createxo.{en,fr}: added exercise models.
2006-07-21: Fixed: in calc_sort(), case of char sort, output string was not
		terminated.
	    Anstype chset: added option "norepeat".
2006-07-18: Added !embraced extract and !embraced delete.
2006-07-11: anstype: protocole clean up and documentation
		(see scripts/anstype/00README).
	    OEF to anstype interface no longer depends on declaration in
		the c source.
2006-07-10: OEF: replytype now defaults to substitution.
	    OEF: total steps should not be shown for dynamic step exercises.
2006-07-09: Symtext: minimal and generic styles for en, fr.
2006-07-05: adm/createxo (en,fr): help on anstype reorganized and completed.
		Added symtext help.
2006-07-04: Added symtext to anstype and text anstype options.
2006-07-02: Added slib/text/cutchoice2 (improved from cutchoices).
	    Updates of Italian version (MC).
2006-06-29: Fixed: presentation problem in help/developer/docqcm.fr (BPR).
2006-06-28: oef2wims + msg2wims:
		"??" no longuer provokes conditional variable.
		Added new function "asis" (string protection).
		The quotation mark now provokes conditional variable only if
		the string before is a valid comparison.

---------------------------------------------
Version 3.56 packed.
2006-06-27: Updates to "mark" series of slib (BPR).
	    Fixed: subsession first accessed with cmd=intro lost user info.
2006-06-24: Update of Dutch version. (JE)
	    adm/class/cdt.fr: added size limitation to prevent overflow. (FG)
2006-06-22: Fixed: inconsistency in update.sh that made update of wimslogd
	    impossible.
	    var.c: VARNAME_LEN doubled to 32768.
2006-06-20: BPR: updated French version help modules:
		help/teacher/docexooef.fr, help/developer/docqcm.fr
	    Symtext: French test version.
2006-06-17: (GK) modified units-filter and the sigunits-related files
            New features:
	    	    - when sigunits is used, the precision is managed separately
		      for each relevant answer (no more interaction
		      with \precision{})
		    - it is possible to give the unit wanted to display the result.
		      it may be a multiple or a submultiple of the base unit or a
		      usual unit outside the mksa system. Examples : nm,
		      km, h, min, A.h, mA.h, kW.h, etc.
		    the additionnal syntax is explained in the help files (en, fr)
2006-06-16: bin/apache-config: added possible apache name "apache2".
2006-06-14: !href: the query string translation was partial. (Thanks to BPR)
2006-06-12: anstype/mark.input: compatibility fix with various browsers. (BPR)
2006-06-07: Fixed: vote name conflicts under gateway. (BPR)
	    Updated: adm/class/cdt.fr. (FG)
	    scripts/adm/class/addclass: added class_creator (client IP).
2006-06-06: scripts/oef/var.proc: suppresses datamodule errors when
	    $allow_missing_data=yes.
	    Update of Dutch version. (JE)
	    Update of Italian version. (MC)
2006-06-05: Thanks to Rafael Hertzog, replaced "sort +n" expressions
            by the POSIX compliant "sort -k n" equivalents (GK).
2006-06-03: anstype/menu and anstype/checkbox: added
	    possibility of including commas in replies.
2006-05-30: Fixed in slib/triplerelation/tabular: replaced many while loops
	    by straight for iterations, cleaned the code by using pari/gp
	    to perform clean matrix operations. (GK)
	    Added command "!getopt".
	    Fixed: in variable.c, check_session(), rapidfire timing check
	    was wrong since version 3.46, due to the use of uninitialized
	    struct st.
2006-05-29: Temp log over cluster sent to separate files, avoiding conflicts.
2006-05-27: Added anstype "raw".
2006-05-24: Fixed: in oef/embed.phtml, matrix should allow double size.
	    anstype/matrix.input, allow smaller input sizes.
	    adm/auth/createqcm.fr and adm/auth/confia2qcm.fr updated (JY).
2006-05-23: Added wims_version to module about page.
	    GK:
	    Renommé avec un préfixe slib_ les variables locales
	    pour slib/chemistry/chemeq*
	    GK:
	    Remplacé plusieurs itérations par l'usage de la
	    primitive "parallel" de flydraw : les chaînes décrivant les papiers
	    millimétrés créées par slib/graphpaper/* n'augmentent plus comme le
	    carré des dimensions.
2006-05-22: calc.c: in list commands, repeated calls to fnd_item() replaced
	    by more efficient cutitems().
	    adm/stat/stat: number of classes and user accounts are shown.
	    GK:
	    anstype/sigunits modifié pour donner une comparaison valide
	    quand la précision demandée dépasse le nombre de chiffres
	    significatifs : les chiffres ne sont comparés qu'à concurrence
	    du nombre de chiffres significatifs (après arrondi).
	    GK:
	    slib/graphpaper/func_milli corrigé : maintenant le rendu des
	    fonctions est correct même si les échelles horizontales et
	    verticales ne sont pas les mêmes.
2006-05-20: Fixed in bin/mkindex: the definition of linelen was too big and
	    did not prevent overflow in home module.
2006-05-19: Misc/modind.c: abort on output file creation failure.
2006-05-18: Added adm/auth/confia2qcm.fr (JY).
	    Added "Cahier de texte" (fr) (FG).
2006-05-15: adm/class/reguser: acceleration in site user counting.
2006-05-14: Added option field to exam exercises, and an option "autogen".
2006-05-13: Datafile: field position cached. (Was quadratic algo.)
2006-05-07: src/Flydraw/commands: fixed bad CR problem (BPR).
	    Added modules/help/developer/docqcm.fr (BPR).
2006-05-06: OEF manager: add an option to allow missing datamodules.
2006-05-03: Fixed: imagefill repositionning not working when there is only one case.
	    Mirror list updated.
2006-05-01: Important updates to Spanish translation (Juan Rafael Fernández).
	    adm/modtool.nl: presentation updates (JE).
2006-04-28: adm/class/config: search for classes (en,fr).
2006-04-28: adm/class/classes: search for classes when there are too many of them (en,fr).
2006-04-26: adm/stat/stat.cn/stat.sh: should be executable.
2006-04-18: adm/class/userlist, userprop: added wrap="off" to textarea (variables).
	    Fixed: wrong data filled in fields when double registering user properties.
2006-04-10: Updates to Italian translations (MC).
2006-04-07: adm/regclass: toomany lockup should not apply to subclasses.
2006-04-02: From GK:
	    slib chemistry/chemeq_tex : support étendu aux équations chimiques.
	    nouvelle slib chemistry/chemeq_compare : compare deux équations chimiques.
	    nouveau type (chemeq) pour les réponses d'exercices OEF,
	    destiné à l'analyse de réponses portant sur des équations chimiques.
2006-03-26: Corrections/improvements in Dutch version (J. Evers).
2006-03-19: calc_rename(): accepts digits in file extension.
2006-03-14: Fixed: texgif font generation conflict among simultaneous visitors.
2006-03-12: scripts/anstype/coord: protection against hacking.
2006-03-09: Flydraw: added a series of commands for advanced matrix manipulations
	    (Jean-Christophe Leger).
2006-03-08: adm/class/sheet: it was unnecessary to disallow source insertion
	    when a sheet is unerasable.
2006-02-21: Improvements to bin/apache-config: more recognitions and
	    special treatment for debian.
2006-02-20: bases/sys/publishdata: added "data" zone.
2006-02-19: Added debian detection in compile, bin/wrapuid and bin/apache-config
	    (Georges Khaznadar).
	    scripts/anstype/atext: translator dictionary was language-independent.
2006-02-18: Added automatic recognition of chemeq and units-filter in chroot.
2006-02-16: OEF hacking bug remained for the last step of a multi-step exercise.
2006-02-08: adm/regclass: level was not shown for individual classes.
2006-02-05: Added a non-processing ocaml interface.
	    Added load refusal according to active process counts.
2006-02-03: adm/vote: added comments. (BPR)
2006-02-02: Added score type option to class userlist interface (Fabrice Guerimand).
	    Included whirlgif to improve gif animation performance.
	    set_req_time(): we must use force_setvar() for otherwise the values
	    are ignored when the user starts with an expired session number.
	    adm/manage: resource uploading installed files to wrong places.
	    Added several chemistry slibs (Georges Khaznadar).
2006-01-29: Ad-hoc solution for file name problem with OSX in scripts/java.
2006-01-25: Added rlimit_as restriction.
2006-01-19: "!read tabletheme" was forgotten in adm/grades. (BPR)
2006-01-17: Corrected a typo in OEF reply variables anti-hacking measure.
2006-01-14: OEF: the choice option "shuffle" was disabled.
2005-12-26: Added OEF reply variables anti-hacking measure.
2005-12-25: Modtool: added processing of module_data.
---------------------------------------------
Version 3.54 packed.
2005-12-22: 2 more mirrors (ofset.org and unicaen.fr).
2005-12-11: variables.c: try_hack() was full of logic errors.
2005-12-08: Parity in shuffle was not working for n>=4 (calc.c).
2005-12-06: Added system level tool: direct exec (en, fr).
2005-12-05: Fixed typos in Dutch version (Joke Evers).
2005-12-04: Added slib series "graphpaper" (Georges Khaznadar).
2005-12-03: A strange bug of bash eats the alias definition in bin/dircptest.
	    Patched scripts in createxo, modtool and bin/mkindex using
	    variable definition.
2005-12-01: Must_chroot was not enforced in software interfaces.
	    Added tolerance to antidated files in wimslogd.
2005-11-28: Exam quitting in gatewayed courses landed to an error message.
	    User activity transfer: added transfer of examlog and exolog.
2005-11-15: Added doc for anstype numexp (Fabrice Guerimand).
2005-10-13: Gateway: program supervisor is now unconditionally granted
	    accesses to courses.
	    Gateway: structure management allows modif of reg password.
2005-10-12: Gateway: added exolog propagation.
2005-10-11: Fixed gateway: prohibition of 09-21 forced students to retype
	    password to go to a course from within a class.
2005-10-10: Fixed gateway: user activity transfer from within a course was not working.
	    Fixed gateway: change user data from within a course by supervisor.
	    Added to gateway: activity transfer now can show activities to transfer.
	    Gateway: add/del user by mandatory course supervisors is now allowed.
	    User deletion from a course is only allowed when he does not have
	    activities in other courses under the same class.
2005-10-09: Fixed: OEF dynamic step post-processing variable updating.
2005-10-08: Use "wrap=off" in textareas in modtool and createxo.
2005-10-03: modind.c: ignores modules with no known category.
2005-09-30: Added wims_realuser (for supervisable users in gateways).
	    Supervisor page now shows name of wims_realuser.
	    useropts saved for wims_realuser, instead of wims_user.
	    mathalign now defaults to lower position.
	    Fixed: doc module html header missed module title.
2005-09-29: Fixed pointer depth error in fsort() (texmath.c). (Why it seemed to work before?)
	    Added module index field "data" (variable module_data).
	    Module index parsing now uses search_list() to accelerate.
	    Added documented command !checkdata.
	    Added a lock in OEF modules when a depended datamodule is missing.
2005-09-28: Fixed: a typo in adm/class/exam blocked exam access when user
	    score data is empty.
	    Added warning message when hack simulation is done on variables (devel).
2005-09-23: Increased software interface timeout values because the new Maxima
	    is slow to launch.
2005-09-22: _getdef(): value should be zeroed by default.
	    Fixed: exercise reindexing from a sharing class broke index file sharing.
2005-09-21: Fixed: gateway: course structure modif from program leads to
	    bad navigation link in page header.
	    Gateway: prohibited student accounts from directly accessing supervisor login.
	    (Minor security precaution)
---------------------------------------------
Version 3.52 packed.
2005-09-19: Added help for the new oef special methods (Bernadette Perrin-Riou).
2005-09-18: Gateway: added several propagation items.
2005-09-15: Dutch translation updates (Joke Evers).
2005-09-14: Textarea nowrap was not compatible with some versions of IE. Trying "wrap=off".
	    Fixed: in gateway, teacher list was not updated after teacher registration
	    using reguser.
	    Fixed: class setup downward propagation ignored courses for programs.
2005-09-13: Fixed: draft document writing was closed in distribution.
2005-09-11: Fixed: user error "double_click" was not flushed.
2005-09-10: adm/modtool: badcategory message now shows available categories.
2005-09-08: adm/class/configure: added index update links.
	    Fixed: class backup did not work when class name contains '/'.
2005-09-07: Added Slovenian version (Bostjan Kuzman).
2005-09-04: Added "shuffle" option to OEF choice options.
2005-09-02: Added a new virtual class connection lock level (7) allowing
	    closing access to participants.
2005-09-01: Added random variable hacking test to scoring devel modules.
	    coord (anstype): stdout from clickzone removed from wims_exec_error,
	    and put into the variable $m_clickzone_error. The latter is reachable
	    from within OEF.
2005-08-27: Fixed: wrong log content dispatching when error found in a logfile name.
2005-08-25: bin/account.sh in the distribution was not updated.
	    Locale fixup at startup: added "LANGUAGE" and "LC_ALL".
2005-08-24: Misc. Dutch retranslations (Joke Evers).
2005-08-23: bin/update killed wimslogd (hence hangs the system when under sysmask orphan).
	    Also bin/server-interrupt.
2005-08-19: Fixed typos in virtual class interfaces (Bernadette Perrin-Riou).
2005-08-18: adm/class/gateway: fixed typos in help links.
	    adm/class/gateway: resource sharing between programs (experimental).
	    adm/modtool: module version check now for all publications.
2005-08-16: Publication of local modules under cluster: touches log/newmodules
	    instead of timestamp.
2005-08-07: rlimit-data lifted to 100M: Maxima-5.9 asks a lot.
	    Fixed compatibility issues with Maxima-5.9.
	    chroot package updated.
2005-07-22: Added config variable "busyhours" and "wims_busyhours".
	    Using wims_busyhours to lock local module publication.
2005-07-06: Added python interface.
2005-07-05: OEF: Message changed for "I don't know" choices.
2005-07-01: Added datamodule access to !lookup.
	    Tolerate module prefix in filename submitted to !lookup.
	    sh and perl commands saved in tmp_dir.
2005-06-30: OEF: variable values made available to help.
2005-06-29: bin/account.sh: do not register partial module addresses.
2005-06-27: Added bin/dircptest to test for switches of cp.
	    Replaced all "cp -PpR" and the like by "dircp", using the test.
	    Typos in French version (Eric Reyssat).
2005-06-26: Wimslogd was killing housekeeping children too fast sometimes.
	    Wimslogd update now goes through tmp/log/wimslogd.new.
	    bin/account.sh was generating some spurious accounting files.
2005-06-25: Bug introduced in software interface rewriting:
	    Feeding to software must be done line by line, otherwise write()
	    blocks at a certain size.
	    Software debugging information was not written when not under multiexec.
2005-06-24: Added special method "help" to OEF.
	    More strict file name check in wims_deposit.
2005-06-23: Added a security message in c/pascal/fortran interfaces.
	    https protocol was lost when a session starts with intro page.
	    Added binary file management to Modtool.
2005-06-21: Added ins_filename variable and slib/oef/insfilename.
2005-06-20: Added datamodule image interface for oef.
2005-06-19: Use ch..root to clean sticky temp session directories.
	    Added datamodule structure.
	    modules/data/ allowed in calc_rename().
	    Added slib/text/octavematrix (Bernadette Perrin-Riou).
2005-06-18: Class navigation under gateway fixed (checks are necessary).
	    Software update scheduling moved from at to wimslogd.
	    Added public_html/bin/convert..switch to automatically patch the
	    convert -dispose switch incompatibility problem.
	    /bin/nongnu obsoleted.
2005-06-16: Added fortran77 interface.
2005-06-14: Added pascal interface.
	    Exec error capture limited to MAX_LINELEN/4.
2005-06-13: chroot package: added pascal and fortran compilers. Updated gcc.
2005-06-12: anstype: c,sh,perl uniformized to "code" with language option.
2005-06-09: OEF: choice/reply/condition weight/option accepts variables.
2005-06-07: Improvement of statistics slib (Bernadette Perrin-Riou).
	    Added oef condition option "hide".
2005-06-05: Clickzone: bound now works without coordinates (two colors mode).
	    OEF contents will be visible to robots.
2005-06-03: anstype/matrix.input: inputsize taken into account.
	    Added recognition of wims_noexport (prohibit specific variable exports).
	    Variables ending with a '_' will are no longer exported.
	    Added export restrictions in oef modules.
	    Added anstypes c,sh,perl.
2005-06-01: Vote: editing form should be post.
	    Msg2wims/doc.c/doccheck(): parbuf size increase 1024->8192.
	    Vote: replaced !writefile by !setdef to extend usable size.
---------------------------------------------
Version 3.50 packed.
2005-05-02: Dutch translation updates (Joke Evers).
2005-04-28: Software about locked up when under multiexec.
2005-04-27: anstype mark did not work properly in extended circumstances.
2005-04-25: chroot was putting subsession to tmp_dir name.
2005-04-24: mhelp in subsession generated module_change error.
	    Exam score was not shown for students with no sheet score.
2005-04-20: _tolinux() was applied on wims_deposit.
2005-04-17: Trailing random string was not removed when not multiexec.
2005-04-15: Bernadette Perrin-Riou and Eric Reyssat:
		Misc. language fixes.
		Modified class presentation (French version).
		New version of help documents.
		anstype help French version.
	    exec '$' double can only be done with a switch!
2005-04-13: Gateway structure interface: added academic level.
	    pariplot and pariray: wrap..exec is not necessary.
	    Superclass/gateway existing user importation: typo in reguser.
	    html/oneitem.phtml: added global label (spurious messages were
	    generated by robots).
	    Octave interface line cutter improved (but may still be incorrect).
	    unset environment variables were a bit too early.
2005-04-12: multiexec method rewritten: 10 fold performance improvement.
2005-04-10: c, sh and perl coderun ready, if with sysmask.
2005-03-12: execution output now doubles the '$' sign.
2005-03-09: userlist csv download was impossible within nested class: embedded '/'.
2005-03-04: config.c: module_langugage -> module_language (J.-P. Giacometti)
	    Preparing for running under sysmask.
	    exported wims_ variables are limited to an explicite list.
	    A few httpd environment variables are unset.
2005-03-01: insdraw filebase session directory should be s2 now.
2005-02-16: Exostat did not recognize classes with non-digits in its directories.
2005-02-04: Bug in html/oneitem.phtml: items lost in type 1 link.
	    Fixed: dependence conflict when manually adding sharings
	    in scripts/adm/class/addshare.
2005-02-03: Typo in exam try number presentation.
	    Class list ignored those with letters in their codes.
	    Spurious messages in adm/class/config/neighbors/addshare.
2005-01-27: bad session number in insertion references under examcheck: fixed
	    (J.-P. Giacometti).
2005-01-26: Added cleantmpdir() to alarm2().
2005-01-25: Automatic update limited to subversion i: extend to r.
---------------------------------------------
Version 3.48 packed.
2005-01-23: home/Subclasses.phtml -> home/Subclasses1.phtml
	    (conflict under case-insensitive systems).
2005-01-22: Fabrice Guerimand: a new french example class (1112).
	    Patch Bernadette Perrin-Riou: presentation fixes to French version.
2005-01-20: Nested use of tmplbuf in read_module_file().
	    Patch Joke Evers: language corrections to Dutch adm modules.
2005-01-19: open/close sheet/exam allow for sharing classes.
2005-01-16: ftest and datafile caches were not zeroed when write to a file.
2005-01-15: Patch Bernadette Perrin-Riou: fixes to presentation problems
	    in virtual class managing modules.
2005-01-14: Cached ftest().
	    log/classes/.build-index changed, adding 3 more fields.
	    adm/class/classes: replace repetitive def lookups.
2005-01-12: Added local session directory s2.
	    insertion files and last.html transfered to s2.
	    misc session files merged to var.stat.
	    check_session(): userlast didn't check existence of lastout.
	    Robot/human detection was dysfunctionning.
	    More zombie killing added to wimslogd.
2005-01-10: Missing space in class supervisor names (adm/class/addclass).
	    var_def_file not defined when module INDEX is missing.
	    remove_tree() now ignores partial errors.
2005-01-09: Proposed class list was wrong for type 2 user registration.
	    System update synchronization within cluster: timestamp.
2005-01-08: Last datafile cached.
2005-01-07: Updates of Dutch class managers (Joke Evers).
	    Robot checker modified to take into account compatible.
2005-01-05: local modules were not referenced when it is a link.
2005-01-04: Maintenance page was locked when wims.conf does not exist.
2004-12-27: (Unsuccessful) robot attacks with multi-word module or cmd confuse
	    log files and accounting: cut to the first word.
	    classes login names with embedded "." leaked thru scripts/adm/class/adduser.
2004-12-26: Patch Bernadette Perrin-Riou: language fixes in French version,
	    message files.
	    Added internal variable wims_sesdir.
	    sessions/$wims_session -> $wims_sesdir
2004-12-25: Basic score computation moved to wimslogd.
	    classes under institution no longer have exo/sheet/exam facilities.
2004-12-19: unix socket added to wimslogd.
2004-12-18: !debug made double substitution.
	    adm/class/stopshare was removing non-shared objects.
	    doc was left over in adm/class/stopshare.
	    adm/gateway/delcourse did not delete users in optional courses.
	    adm/class/deluser did not delete user records in optional courses.
2004-12-17: adm/class/userlist: activity transfer for participants
	    (only for institution structure).
	    adm/class/reguser: bug for superclass user registration.
2004-12-16: adm/class/config: some class setups can be sent to subclasses.
	    adm/class/regclass: authentication procedures changed.
2004-12-13: adm/class/makeuserlist regenerated userlist at every call.
	    Recovery of deleted users was broken (independent classes).
2004-12-11: !append passed string end when second parameter was empty.
	    calc_rowof() had no right to use tmplbuf.
	    Newly created classes under a class group is now a subdirectory of the group.
	    Institutional structure is working.
2004-12-10: Label '*' absorbs every !goto now.
	    Variable declarations with name ending by '0' were not taken into account.
2004-12-06: Added cut time for exams.
---------------------------------------------
Version 3.46 packed.
2004-12-03: Suppressed file_too_long message from !defof.
2004-12-01: Log long execution time in access.log.
2004-11-29: Added nested read level check (was crashing when there is infinite loop).
	    One more write to readonly string in set_vars_from_parm().
2004-11-28: New anstype: sigunits (G. Khaznadar).
2004-11-27: wims_myhostname did not give permanent hostname.
	    (Volatile hostname isin httpd_HTTP_HOST.)
	    exam_currscore(): session_prefix used before definition.
2004-11-26: !shuffle result in case of one non-numerical item: should give
	    the item itself instead of a "1".
2004-11-25: Added while loop (!while ... !endwhile).
2004-11-24: bin/mkindex becomes non-interrupting.
	    local module publication chains bin/mkindex (thru wimslogd).
	    Added indication of local and com modules in search results.
2004-11-23: Insertion of devel modules into worksheets: site-configurable policy.
2004-11-21: variable buffer extended to 16*256K.
	    flushoutput() was missing in robot error output.
2004-11-19: write to readonly string in set_vars_from_parm().
	    exec_href(): lbuf copy length too short (robot access case).
	    Modtool now shows oef compilation errors.
2004-11-18: headmenu disappeared within exam check.
	    Insertion of devel modules into worksheets disabled.
	    Exam score counting error corrected.
2004-11-17: user-deposit must be readable by all (files are moved elsewhere).
2004-11-16: Distribution bug: bad modules/classes content distributed.
	    compare(): pointer typo.
2004-11-14: freepar_* variables will not be checked for parentheses.
2004-11-13: !values, !makelist etc. was not correct when list is empty
	    or when step is negative.
2004-11-10: Spurious "expression" message when search keyword contains
	    accents: fixed.
2004-11-08: classes/* become trusted modules (need this to access class dir).
	    Facility for class participants to use createxo was erased.
	    Expiration was not correctly formatted in home page for robots.
2004-11-06: calc_examscore() moves to cutwords().
	    Exams now can define starting primes.
2004-11-04: Octave for chroot: usr/libexec/octave was forgotten.
2004-11-01: Added ftest().
2004-10-31: Sorted var_def. VAR_DEF structure compressed.
	    set_vars_from_parm(): force_setvar() -> setvar().
	    Quadratic nospace() and singlespace() replaced.
	    Added #define MAX_FNAME and mkfname().
2004-10-30: get_var_defs() rewritten.
	    Definitely obsolete never used var.def columns: log, ulim, llim.
	    New var.def format: "reply: ...."
	    However, still no check against repetitive definitions
	    of a same variable.
	    calc_sort() rewritten.
	    Quadratic randperm() replaced.
	    Added int2str() in wimslib.
	    Eliminated uselessly initialized long buffers.
2004-10-29: Class codes no longer need to be an integer.
	    Added cutitems(), cutwords() and cutlines().
	    exec_distribute() changed to use cut.....().
2004-10-28: Added translation tool: bin/new-files.
	    Site manager can now visit several developer accounts.
	    compare() rewritten.
	    calc_append() and substit() optimizations.
2004-10-27: Cached working files.
	    wims.conf: erase backslash before saving from adm/manage. However,
	    backslash at the end of a line will still create buggy situations.
2004-10-26: key routines var_proc() and phtml_put() optimized.
	    Slight modification of WORKING_FILE structure.
	    output() refinement.
2004-10-25: mailurl algorithm moved to scripts/mailurl.proc.
	    Reduce MAX_FOR_LEVEL to 12. Should be largely enough.
	    Rewrite open_working_file(), reducing the number of strchr().
2004-10-24: Various code cleaning of the main program.
	    Acceleration in save_session_vars(), and increase oef var limits.
	    module_error() variables switched from setenv() to setvar().
	    !readmotd and !writemotd removed. (undocumented commands.)
	    These were used in home module and adm/class/motd.
	    Replaced by !fileread, !filewrite and !read.
	    Therefore now motd files are fully phtml ones.
2004-10-23: Start replacing tags by lower case.
	    added readfile(). Rewriting several functions using it.
	    Change !mailurl encryption method.
	    wims_myip removed (waste of time).
2004-10-22: wims_trustfile was not working correctly.
	    insdraw_filebase was blocked for class documents.
	    Security check against links "sessions" "classes" or "doc" in
	    adm modules is longuer needed: removed.
2004-10-21: introduced mystrncpy(): replace snprintf() and strncpy().
	    Quadratic strcpy() replaced in _tolinux().
	    Quadratic find replaced in exec_distribute().
	    Quadratic algorithm replaced in _blockof().
	    wims_prefix removed from internal_name table.
2004-10-20: Automatic module update not working when delay >= 7 days: fixed.
	    Quadratic strcpy() replaced in open_working_file().
2004-10-19: Bad variable name (parm) in html/themes.phtml.
	    Software about disapeared in about page: turn off multiexec in about.phtml.
2004-10-18: adm/manage: added restore.
	    Backup file number reduced.
	    File management in online maintenance becomes operational.
2004-10-17: added !mailurl (counter-spam crypted email interface).
2004-10-10: Large file download: was cut off by alarm limit,
	    now available for 100kb/s or more.
2004-10-09: "all" allowed in host checking.
2004-10-08: Broken sheet file blocked supervisor home page: fixed.
	    adm/class/userlist, userprop: user variables disappeared.
2004-10-04: instexst(): file mtime tag disappeared since 3.42.
2004-10-02: Added other/bin/passcrypt
2004-10-01: Allow edition of help/ in modtool.
	    adm/class/config.??/help/config.phtml was bounding readonly variable.
2004-09-30: adm/class/regclass.it was dysfunctionning.
	    motd did not appear in the first participant page.
	    adm/class/classes was putting logs in module directory when
	    visited by site manager.
---------------------------------------------
Version 3.44 packed.
2004-09-30: adm/modtool was silently cutting file lengths.
2004-09-27: wims_myhostname and wims_myip made available to home module.
2004-09-24: Votes added to class sharing list (non-verified).
2004-09-23: Debugging line not erased in modules/adm/userlist.en/var.proc.
	    Class logo whas not changed for user pages.
	    Remnant !debug erased in modules/adm/forum/mboard.
	    adm/class/config.nl was sending broken emails (space after \ ).
2004-09-21: class oef disappeared except for French version.
2004-09-20: exec.type limited to 256 (is it enough?).
---------------------------------------------
Version 3.42 packed.
2004-09-19: scripts/adm/class/mkuserlist crashed when login starts with '-'.
	    adm/new.?? system changelog now points to src/Changelog.
2004-09-16: Class forum and userlist csv download missing data under superclasses.
	    Added \doc{} to documents (help not updated).
2004-09-14: Allowing negative scores (to be used only in special modules).
2004-09-13: Printable versions now give no reply to students.
2004-09-07: A better management/messages for non-installed softwares.
	    added !perl for trusted modules (non-documented).
	    class exercise restore/import bugs fixed.
2004-09-03: chroot execution of sensitive programs.
2004-08-31: fixed votedir error in adm/vote.??.
2004-08-29: Slight modification in the algorithm of bin/mkpopular: use sqrt.
2004-08-25: Removed last symbolic links to classes and sessions in modules/.
2004-08-20: OEF terminology: session->series, séance->série.
	    Score quality now uses a geometric series, the more recent being
	    more significant.
2004-08-16: added scripts/adm/class/authprep.
2004-08-10: last.html disabled for test sessions.
2004-08-09: untrust propagation after !record...: corrected.
2004-08-02: Internal names: wims_priv_*.
2004-07-31: Eliminate symlinks: rest of adm modules.
2004-07-30: Eliminate symlinks: home, amd/createxo, adm/vote, adm/manage,
	    adm/raw, adm/browse, adm/class/addmodule, adm/class/classes,
	    adm/class/stat, adm/class/reclass, adm/class/reguser,
	    adm/class/passwd, adm/class/grades, adm/class/exolog,
	    adm/class/exam, adm/class/sheet, adm/class/userlist.
2004-07-29: added internal function find_module_file().
	    Eliminate symlinks: adm/modtool.
	    Record files in mutual directories now work.
2004-07-06: Table appearance: createxo helps.
2004-07-03: var.c: setting empty variable was giving NULL.
	    added 2 embeddable js calculators copied from javascriptsource.com.
2004-07-02: Name change: WWW Interactive Multipurpose Server.
	    Modtool: Remake def when src erased.
	    Non-initialized information in post_log().
2004-07-01: Appearance theme management: see public_html/themes/.README.
2004-06-29: Table appearance: forum/forum, stat/stat, class/stat,
	    class/config, class/userlist, doc.
	    spurious error in adm/createxo oef registration corrected.
	    Exercise importation bug in classes (def directory not created).
2004-06-28: C lvalue casting corrected (6 locations for qsort subroutines).
	    Table appearence uniformization: manage,modtool,classes,new.
	    Automatically incrementing variable: wims_incremental
	    Class importation of exercises: import images too.
	    Globally replaced "&>/dev/null" by ">/dev/null" in scripts.
---------------------------------------------
Version 3.40 packed.
2004-06-26: Added wims_sesrandom (64 session-static random numbers).
	    Parameter space overflow in bin/mkindex: switch to translator file input.
2004-06-24: A more correct POST timeout check.
2004-06-23: strip_enclosing_par() did not check unmatching: sigsegv.
2004-06-22: '~' in devel module names was disliked by image programs.
2004-06-21: added anstype/numexp (Fabrice Guerimand).
2004-06-20: misc documents closed to robots.
	    Rafale check disabled for exams.
	    added module adm/new.
	    option and weight fields of oef replies now operational.
	    Random generator switched to Mersenne Twister by
	    Takuji Nishimura and Makoto Matsumoto (Lib/mt19937ar.c).
2004-06-15: added !embraced.
2004-06-13: wimslogd reads and executes log/wimslogd.exec
	    !module now returns empty if module does not exist (instead of current module).
2004-06-12: Automatic module updating.
2004-06-09: Individualized sheet opening was not working under superclass:
	    wrong user file in _subword().
2004-06-08: Document modules under Modtool, with document manager.
2004-06-07: New config parameter: aliased_getfile.
	    Enhanced Modtool with publication manager.
2004-06-06: version added to module index.
2004-06-05: added other/bin/src2def.
	    oef, deductio and document modules: suppression of symlinks and executables.
	    update-version upgrades to 337.
2004-06-02: Search by author name activated.
	    Added config parameter wims_showauthor.
2004-05-31: Trusted modules can access wims_home.
2004-05-29: Improvements of robot pages.
	    chemeq, units-filter and wimsd non-blocking compilation failure.
	    chemeq and units-filter added to support software checklist.
2004-05-26: Antidated modules are now blocked.
	    Keywords from popular search engines retaken by WIMS home page.
2004-05-22: General reference page using wikipedia.
2004-05-21: translator now accepts very long sources.
2004-05-13: download/wimsget was broken.
2004-05-09: Added sheet data into exam log.
2004-05-08: Voter listing was not correct under superclass.
2004-05-04: Set-styled replies with embedded ';' are rejected.
2004-05-01: getfile did not search for directory in parent session.
2004-04-24: Dynamic condition list in oef.
2004-04-16: Vertical stacking in clickfill and dragfill.
2004-04-14: Portability extensions by Karim Belabas.
---------------------------------------------
Version 3.36 packed.
2004-02-17: Bug fix: class images do not appear in exams.
2004-02-13: Multiple bug fixes in superclass structure.
2004-01-18: Added virtual class hierarchy.
2004-01-14: msg2wims moved to WIMS_HOME/bin.
2004-01-12: Configurable computational precisions in OEF modules.
2004-01-08: Document modules with manager in scripts/docu.
2004-01-05: Direct importation of public sheets into classes.
2004-01-03: Access policy configuration extended to virtual classes.
2004-01-02: Site resource access policy configuration.
2003-12-17: User error kicked participants out of the class.
2003-12-16: Sheet printable version was not working for class exercises.
2003-12-07: Rafale locks account for 10 minutes against relogin.
	    Rafale in class partly counted as new.
	    Mixture with suspended activities also disables score in classes.
	    Scores immediately following a large series of rafale are ignored.
2003-12-06: Classes allowing output of resources to all (manual declaration only).
2003-12-05: Expired sheets with 0 weight no longer shown in participant score list.
2003-11-27: modind bug fixed: modules not in site language list now ignored.
2003-11-26: Site configuration: eliminate language repetitions.
2003-11-24: Software non-installed message was not available due to a bug.
2003-11-23: config variable: default_texposition.
	    user tex size is now absolute.
	    \oefenv was not available within createxo.
2003-11-22: texgif: tfm files were copied to current working directory.
---------------------------------------------
Version 3.34 packed.
2003-11-18: Bug fix: add participants using csv.
2003-11-16: New reply type: range.
	    OEF: kill score genration in debug mode.
	    Close participant exam sessions by supervisor.
2003-11-15: Deactivation of a sheet.
	    Allow supervisors to test exams under preparation.
2003-11-14: Added to oef: \oefenv, debug mode.
	    incomplete addressing in documents and OEF draw: fixed.
2003-11-13: Drag & drop window resizing bug fixed.
2003-11-09: added !makelist.
2003-11-08: Some bug fixes in printable version of sheets (datafile bug remains).
2003-11-01: affine transformation added to flydraw.
2003-10-31: wims_exec_error becomes cumulative.
	    wims_exec_error reported in Createxo.
	    motd (message of the day) files moved to log.
2003-10-28: New version of OEF and deduc avoiding the use of symlinks.
2003-10-27: .wimspass moved to log directory.
	    oldclasses moved to backup.
2003-10-26: added OEF \special method: imagefill.
2003-10-25: idle-time split to 3.
	    writable directories moved to w.
2003-10-24: algexp, litexp and formal accept multiple good replies (separator=,)
	    oef2wims added error messages.
	    file mode in Createxo.
	    The main program is now staticly linked (exec performance).
2003-10-23: Some cleanup of directory settings:
	    wims.conf moved to log directory.
	    forums moved to log/forums.
	    instex and mathfonts/texgif moved to w (relocatable directory).
2003-10-20: added exolog: exercise registration for virtual classes.
2003-10-16: backup and accounting moved to wimslogd.
	    TeX floating level added to useropts and preference page.
2003-10-15: OEF: added \special{}.
2003-10-13: adm/class/regclass was setting wrong class version (3 instead of 4)
2003-10-12: Dutch version (Joke Evers).
	    Supervisor can select existing class exercises in Createxo.
	    OEF: TeX images accepted in type=radio and type=checkbox.
	    !date reopened for general modules, with stricter security restrictions.
2003-10-11: !for x=1..5
2003-10-05: log files now use wimslogd to dispatch.
2003-10-04: Many temporary files moved to tmp/sessions.
	    added wimslogd (autorun log daemon).
---------------------------------------------
Version 3.32 packed.
2003-09-28: !date is now for trusted modules only.
		(others can use $wims_now and $wims_nowseconds)
	    !sql dereferenced.
	    Online management: mkindex now sent to at (had rlimit_cpu overflow).
2003-09-27: Online update, backup and crontab managements.
2003-09-22: Misc. bug fixes in virtual class management.
	    2D array addressing. Availability in OEF and doc.
2003-09-21: clickfill and dragfill: fields of multiple length.
	    Array addressing: $(var_name[item_numbers])
2003-09-20: different DynAPI replies can now coexist.
2003-09-18: Bounding bug in !randint (when only one bound is given).
2003-09-16: _tolinux() becomes more agressive.
	    setvar() always calls _tolinux().
	    bin/mkindex command line overflow in OEF sorting: fixed.
2003-09-15: Class load accounting in site management page.
	    Internal variable: wims_now, wims_nowseconds.
2003-09-14: OEF draw within parameters: redrawn (up to 16) when cmd=resume (saved exercises).
2003-09-13: new OEF answer type: dragfill.
	    Spurious password check bug in adm/userlist.
2003-09-11: added ccsum (user and class connection time accounting)
2003-09-10: new OEF answer type: clickfill.
2003-09-08: new OEF answer type: coord.
2003-09-06: added !rows2lines (non-documented).
	    rows2lines() now ignores semicolons enclosed in parentheses.
2003-09-05: DynAPI 3.0.0.
2003-09-03: added clickzone (for use in reply type `coord').
2003-09-02: flydraw uses `convert' to read images of other formats.
2003-08-28: added interface to DynAPI.
	    OEF answer types based on DynAPI: correspond, reorder and compose.
2003-07-19: draw() added to OEF and doc parameter primitives.
	    Image clock available in OEF.
2003-07-18: added !rename (name hiding for multimedia files in exercises).
2003-07-13: Server update and backup management in adm/manager.
2003-07-09: !pedia method moved to script (pedia.phtml), using wikipedia.
2003-07-08: Personal passwords now use crypted storage.
2003-07-06: Class oef structure reorganized (modules/classes/$wims_class removed).
---------------------------------------------
Version 3.30 packed.
2003-06-30: Expert menu in OEF manager (F. Guerimand).
2003-06-28: User-friendlyness improvements in exam page.
2003-06-24: Exam detail log and check.
2003-06-23: write_logs() and save_session_vars() interchange order.
2003-06-19: Forums: supervisor now can read erased messages.
2003-06-18: added cmd type `next'. Existing modules modified.
2003-06-14: added !sum, !product, !recursion.
	    !values can do recursive computations with variable `last'.
2003-06-13: added log2() (kernel and interfaces).
2003-05-29: added !reaccent.
	    added list of new OEF.
2003-05-27: added oncechar (special-purpose program).
2003-05-25: numerical integration in slib/integrate switches to very slow but
	    much more secure method (with pari).
2003-05-25: Wording: score average -> score quality.
2003-05-24: Using image.src for imgcomp reply type: doesn't work for Netscape 4.
	    (And isn't really conform to javascript specs.)
	    OEF printable version: variable grouping bug fixed (new line in values).
	    Printable version of user help.
	    Integral version of Createxo help.
2003-05-23: A few predefined variables for documents in classes.
2003-05-22: Documents: gnu means Free Documentation License.
2003-05-19: Update of Chinese adm modules (Z. Chen).
2003-05-18: Show exercise source list in documents.
2003-05-17: Printable version of documents.
2003-05-15: Styled fills in flydraw (hatching etc).
2003-05-10: added wimsd.
2003-05-08: Main word dictionary renewed (en/fr).
2003-04-29: Installation scripts adjusted for RedHat 9.
2003-04-24: added class_option.
2003-04-22: added anstypes imgcomp and textcomp.
2003-04-17: Integration in OEF and Doc now calls slib.
2003-04-14: Spurious solutions in solve() when root is exactly a cut point.
2003-04-13: added !lookup.
2003-04-07: confparm (1-4) added to OEF manager.
2003-04-03: Robot referencing scheme created recursive fake directories.
2003-04-01: Robot visibility of documents.
---------------------------------------------
Version 3.28 packed.
2003-03-25: Createxo open to class participants.
2003-03-23: Link between vote and access control.
	    User property changes: !setdef instead of !writefile.
2003-03-22: Vote system for virtual classes.
2003-03-21: A series of French documents submitted by B. Perrin-Riou et al.
2003-03-18: hint disallowed during exam.
	    cookie disorder in exams when cookies are activated in classlock.
2003-03-15: !values added ... for v in v1,v2,v3,...
	    `!random a,b repeat n' and `!randint a,b repeat n'.
2003-03-14: erf() and erfc() added to evalue().
2003-03-13: numerical integration in OEF/DOC now uses romberg() in MAXIMA.
2003-03-12: User asking for unavailable language provokes internal error.
	    !rawmath was adding spurious () after function names.
2003-03-11: New OEF reply types: checkbox, click, menu, radio.
2003-03-09: Supervisor now allowed to import public OEF exercises.
2003-03-08: Use cpp to process pre-source OEF and DED.
2003-03-07: Internal: added cutfor() for calc_solve() and calc_values().
2003-03-06: Variable name substitution in !values.
2003-03-05: Rapidfire requests for printed versions are disabled.
2003-02-28: WIMS now refuses to process executable files.
	    slib indexing and documentation.
2003-02-21: New reply type to OEF: chset.
2003-02-20: Fixed: segfault when HTTP_USER_AGENT is not defined.
	    Dynamic insertion in mhelp was in conflit with parent session.
	    Document pages requiring preserved \(...) recompiled.
	    slib structure added.
2003-02-17: More dependency program checks are included in maintenance tool.
2003-02-15: items2words() now respects parentheses-protected commas.
2003-02-13: user_error while outputing was not sent out.
	    getins w/o file name provoked segfault.
2003-02-12: Recognition of x', y'', etc. in formula processing.
2003-02-11: New reply types to OEF: fset and aset.
2003-02-10: Double call to authdelay when auth starts using user=...: auth always failed.
2003-02-08: texmath() bug for matrix exponentials.
2003-02-06: 2 wrong pointers in online maintenance page.
2003-02-05: Class document accessibility was not checked.
	    mhelp within subsession did not work.
	    Timing facilities added to OEF manager.
2003-02-03: More countermeasures against rapidfire exercise requests.
	    forum thread navigation bug fixed.
---------------------------------------------
Version 3.26 packed.
2003-01-26: forum/mboard/scripts/quote.sh was using m_* variables (no longer available).
2003-01-25: added umask(022) at the beginning of wims.
2003-01-24: bin/ins???..processor were erased by 'make distclean'.
2003-01-22: webget connection restrictions.
	    Delay for wrong user authentification: 5 seconds.
2003-01-21: Error messages are shown in the page when insert fails.
2003-01-20: Countermeasures against rapidfire exercise requests within worksheets.
2003-01-19: Missing software now generates user error.
2003-01-18: Library functions: filelength() and catfile().
	    modtool accepts OEF and Deductio modules.
	    mkpopular modification: accounting of different languages are now mixed.
2003-01-09: Output delayed to the end of the processing, using last.phtml.
	    Grouped execution of instex.
2003-01-07: OEF tex format $ translation bug fixed.
2003-01-06: evalue_compile() bug fixed (recognition of scientific notations).
2003-01-03: insmath_logic starts to work.
2002-12-30: mathexp now uses regex for conditional extract.
2002-12-20: configure: static link now checks existence of static library.
---------------------------------------------
Version 3.24 packed.
2002-12-01: Some bin programs switched to static linking, accelerating execution.
2002-11-28: Deductio starts.
2002-11-23: Maxima multiexec now uses line by line method.
2002-11-21: Cookies were interfering with popup mode.
2002-11-12: \(..) usedynamic bug fixed (several insmath in a same line).
2002-11-02: `!if .. issametext ..' was case-sensitive.
2002-11-01: latex2html (2002-1) fails when TMPDIR is set: unset before calling latex2html.
2002-10-31: oef2wims bug: file size limited to 16K.
	    oef2wims starts to print error messages.
2002-10-24: Score counting: new and hint are separated.
	    \help added to OEF.
2002-10-21: WebCopier is a very bad browser.
2002-10-20: Cleaned treatment of special characters in oef and doc.
2002-10-17: Takes care of response header fields 'Server:' and 'Status:'.
2002-10-16: Links for class authentification moved to adm/class/classes.
2002-10-14: \(...) usable in parameters and prompts of OEF.
2002-10-13: Fixed multiple folding bug in doc.
2002-10-10: Updates in Italian translation (Marina Cazzola).
	    Current server activities in online maintenance tool.
2002-10-08: Replaced [ ... -a ... ] and [ ... -o ... ] in shell scripts.
	    #!/bin/sh replaced by #! /bin/sh in shell scripts.
2002-10-07: oef2wims added mdef method (internal use only).
2002-10-06: Rational datatype activated in OEF and DOC using pari,
	    and complex datatype modified ('*' no longer translated to ' ').
2002-10-05: Bug in _subword(): strcpy() passes over string end.
	    Bug in user importation page (neighboring classes).
	    Bug in exo importation (when the importing class has no exo).
2002-10-04: Introduced configurable parameter default_anim_format (gif/mng).
2002-10-02: Extension and configurability of login/password limitations.
---------------------------------------------
Version 3.22 packed.
2002-09-30: Makefiles rewriting: whildcards, check before strip.
2002-09-29: Build options (dynamic, units, chemeq) added to configure.
2002-09-28: strtok() no longer used.
	    PATH definition is now dynamic.
2002-09-27: Portability to case-insensitive file systems.
	    Score dependency is deactivated when scoring is closed (sheets).
2002-09-26: Starts to use autoconf. Some first portability declarations.
	    Added `make distclean'.
2002-09-24: Link to Modtool in virtual classes.
2002-09-23: File deposit length limit can now be increased
	    independent of QUERY_STRING_LIMIT.
2002-09-22: Use internal variable manager; important acceleration.
	    $module_about is now only prepared when cmd=help.
	    Style sheet defaults to justify.
2002-09-21: string_modify(), substit() and float2str() cleaned and accelerated.
	    SUBST_LIMIT has changed meaning: now limit of nesting levels.
	    texgif acceleration: call_sh() -> execredirected().
	    Now tex is executed by safe uid.
	    oef and doc now makes use of static instex.
	    Added utility script 'oefcompile'.
2002-09-20: OEF variable number limit grows to 1024.
2002-09-19: Math middle alignment floats back, and prepared for configurability.
	    pari/gp temporary directory now correctly set.
2002-09-18: Fixed document indexing bug in distributions.
	    OEF manager variable saving method reorganized.
	    Number of replies and choices increased to 20 each.
2002-09-16: multiexec installed (only effective on ELF-interfaced programs).
	    The method of waitpid(..,..,WNOHAND) was wasting lots of cpu load.
	    Replaced by alarm(). Global time limit is also installed, with
	    a new module error message (timeup).
2002-09-15: exec_exec() removed (unnecessary).
	    !sh will no longer output when not outputing.
2002-09-14: Interfaces: added common.c.
	    Interfaces: illegal names are renamed instead of refused.
	    Interface to pari/gp: compatibility with version 1 deplecated.
2002-09-12: Mirror list update.
2002-09-11: Child process not loaded if no time left.
	    Post-reply variable processing in OEF exercises.
2002-09-10: Mirror site list accepts https sites.
---------------------------------------------
Version 3.20 packed.
2002-09-09: substitution forgotton in !text reverse.
2002-09-08: Absolute execution time limit to child processes.
	    Middle alignment of instex floates back to base.
2002-09-07: Bug in !htmlmath: e^-(2x) => e<sup>(2x</sup>.
2002-09-06: !solve did not accept substitution in variable name.
2002-09-02: Added configurable virtual class connection locks.
2002-09-01: Session cookies activated (configurable).
	    user_agent change within a session is now disallowed.
2002-08-31: Added class logo configuration.
	    Secure hosts added to class creation tool.
	    imagedir bug in OEF printable version (almost) repaired.
2002-08-30: Homepages header technical reorganization.
	    Modules: <input><br> --> <input> <br> to patch netscape justify bug.
	    Exam js clock bug fix (empty variable).
	    Homepage menu links (new, forum, ...) always pointed to English version.
2002-08-29: Appearance configuration (bgimg, css) for virtual classes.
	    background image file generator.
2002-08-28: Site-wide css definitions.
	    mhelpheader.phtml refined.
2002-08-27: Config parameter class_regpass is activated, for class creation rights.
	    page bgcolor becomes globally configurable via page_bgcolor.
	    Site-configurable background image files.
	    Presentation setup now also applies to homepage.
2002-08-08: Added program huffman (variable length encoding).
2002-08-07: Added internal variable wims_developer to keep developer authentification.
2002-07-31: Added variable wims_htmlbody. Global page modifications using it.
2002-07-27: More strict name check in file deposits.
	    Developer account management added to online site manager.
	    useropts now kept in user definition files (in virtual classes).
	    Change background colors for virtual classes.
2002-07-25: File deposit in Createxo (within virtual classes).
2002-07-23: Mirroring virtual classes.
2002-07-22: Interface to Yacas.
2002-07-20: Direct connection interface with other web servers.
2002-07-18: More variables for document page replacements in virtual classes.
2002-07-17: added exec_sh (was using calc_sh).
2002-07-16: adm/ subdirectory in scripts/ only accessible to trusted modules.
	    Direct link for editing work sheet presentation page.
	    Modify class property by site manager erased supervisor password.
2002-07-15: EmailSiphon is a very bad browser.
	    https added to webget (depends on openssl).
	    OEF wlist input bug (a line of code is missing).
2002-07-09: gifs directory opens for read by insdraw.
2002-07-07: oef2wims bug fix: nested \for variable set, multi-line variables.
	    General tool link available to class participants.
2002-07-03: \step enters into feedback conditions.
2002-07-02: big/small endian bug fixed in texgif (tfm.c)
---------------------------------------------
Version 3.18 packed.
2002-06-29: added class_quota, doc_quota, class_regpass, doc_regpass to config.
	    Disk quota system for documents and classes.
	    File deposits in documents.
2002-06-25: Score dependencies in exam sheets.
2002-06-23: Score dependencies in work sheets.
2002-06-22: Possibility to replace virtual class user pages by document blocks.
2002-06-19: Multi-step answers in OEF.
2002-06-17: \if and \for added to OEF syntax.
2002-06-14: doc: parameter substitution forgotten in \link, \embed and \target.
2002-06-13: sh script trying strict conformity: $[...] -> $((...))
2002-06-09: Neighboring classes: exercise importation bug fixed.
	    Exam page deactivated when try number is exhausted.
	    Erase sharing links when erasing an expired class.
2002-06-07: Reset variables in oef printable version, between each exercise.
2002-06-01: ins_limit default lifted to 150.
	    Italicized letters in htmlmath.
	    Rationalization and acceleration of !insmath.
	    Cleaning old instex pictures in housekeep.daily
2002-05-31: Reusability of static instex.
2002-05-30: Automatic recognition of LaTeX source in texgif (rudimentary).
	    LaTeX source submission in documents (relies on LaTeX2HTML).
2002-05-29: user_log() => segfault on public sheet (classe=NULL)
2002-05-28: Createxo.fr raw mode was not updated ?!
	    createxo (en,fr): erase old submit.def before generating new one.
2002-05-26: added !solve.
	    Virtual classes: comparison with average scores by participants.
2002-05-25: OEF reply and choice order is now changeable by author.
	    Embedded replies in OEF manager.
2002-05-23: Static and dynamic compilations.
2002-05-22: Parent session erasure bug during exam.
2002-05-21: Opera added to good agent list.
---------------------------------------------
Version 3.16 packed.
2002-05-20: Added activity statistics for virtual classes.
2002-05-13: Bug fix: exam simulation was prohibited by class-wide restriction.
	    Added !values, !leveldata.
2002-05-11: Added evalue_compile(), levelcurve().
2002-05-10: Code reorganization: start using dynamic libwims.
2002-05-06: Modtool added backup and restore.
2002-04-27: Curve comparing program: curvecomp.
2002-04-25: java input applet.
2002-04-24: Document-wide header definition.
	    Added alt= to instex.
2002-04-23: insplot bug: insplot_data was not reachable from another request.
2002-04-18: New message alert in virtual classes.
2002-04-16: Erase documents by authors.
---------------------------------------------
Version 3.14 packed.
2002-04-14: New comparison relations: issametext, issamecase
2002-04-12: Font color in dvigif (via \special{color=...}).
2002-04-11: Subscription bug fixed in htmlmath() and texmath().
	    special functions in oef2wims and msg2wims unified.
2002-04-07: added !readproc.
2002-04-06: \form, \if and \for available for documents.
	    added !row, !rowcnt, !randrow ... (internal and undocumented).
	    added !text reverse
2002-04-05: Documents now accept parameters (parm1..parm20).
2002-04-04: Exam interface re-designed: no need to register, etc.
	    OEF reply conditions and feedback tests accept special functions.
	    cleaning() includes tmp/sessions directory.
	    flydraw moved to other/bin, for secured execution.
	    OEF and doc draw accept animations.
2002-04-01: OEF input analyzing scripts moved to public place.
2002-03-30: Some remaining calls to isfinite() changed to finite().
	    Trying to define a NAN for systems having no such definition.
	    Added !select (for columns/rows) and !column.
2002-03-27: exec security enhancement via wrap..exec.
---------------------------------------------
Version 3.12 packed.
2002-03-18: OEF atext input added relevancy check.
2002-03-13: Patch for gd 1.2: border check in filltoborder.
2002-03-12: Createxo reinput forgotten in raw mode.
2002-03-05: Hidden variables in function reply (items 2 and up).
2002-03-04: \draw in documents did not accept parameters.
2002-03-01: Added simplify() to OEF and doc syntax.
2002-02-28: OEF units input manager bug fix.
2002-02-27: Erasing some unused commands: splitlines, ...
	    Security enhancements in commands.
2002-02-23: Direct texgif, bypassing gs.
2002-02-17: Typo in oef2wims: statement processing stopped after \draw.
2002-02-15: Added randomrow and randomitem to OEF and doc syntax.
2002-02-14: Createxo multiple choice fields reinput typo.
---------------------------------------------
Version 3.11 packed.
2002-02-11: oef2wims: translation of ! distroys comparison conditions.
2002-02-10: Added type case, nocase, atext, wlist to OEF input.
2002-02-08: Added matrix, \rows, \row to OEF and doc syntax.
2002-02-06: Modtool authentification bug fixed.
	    condition tester accepts || and &&.
2002-02-05: Fixed mhelp session bug when caller is a subsession.
2002-02-04: !shuffle can now directly shuffle lists.
	    OEF manager added printable version.
	    Fixed variable order bug in sheet printable version (executed statement).
2002-02-02: Direct authentification with password (home module only).
2002-01-31: Dynamic drawings in documents and OEF exercises.
2002-01-29: Site document secret codes were included in distribution.
2002-01-28: Date error: Popularity counts were reversed.
2002-01-23: Bug in class user registration: firstn, lastn, email becomes litteral.
2002-01-22: Appearance modification allowed for active worksheets.
2002-01-21: Bug in sheet manager: good sheet erased in special circumstances.
---------------------------------------------
Version 3.10 packed.
2002-01-14: rpm packages (i386-Linux).
2002-01-10: Class management by site manager.
2002-01-05: Printable version of worksheets.
	    oef2wims: `!' becomes litteral.
2002-01-04: Erase messages by forum supervisor.
2002-01-02: Class forum moved to class directory.
2002-01-01: Class authentification method changed (now use adm/class/classes)
		Limited compatibility in the home module.
	    Change class within neighboring virtual classes.
	    Added !sh.
2001-12-30: Neighboring classes: resource importation and sharing.
	    `>&/dev/null' replaced by `&>/dev/null' in shell scripts.
2001-12-28: Added !restart (change module). For trusted modules.
2001-12-26: Virtual class selective backup and restoration.
	    Online configuration of virtual classes.
2001-12-24: added !defread (non-documented).
2001-12-23: Added checkhost() and !checkhost (non-documented).
	    Definition of secure hosts for class supervisors.
2001-12-22: Security enhancement in class/forum/doc registration managements
		(special characters).
2001-12-21: Spreadsheet link in virtual classes (English and French).
2001-12-19: WIMS changes name extension at dynamic insertion.
	    Added command `getfile'. All files are application/octet-stream.
		For trusted modules, non-documented.
2001-12-18: added !setdef (trusted modules only).
	    Change participant properties by class supervisors.
	    Recover deleted participants. Add user by supervisor.
	    !filelist must use call_sh() instead of call_ssh(), for pathname expansion.
2001-12-16: Normalisation in support software configuration parameters.
2001-12-14: Virtual class changed to version 3: file locations moved.
	    Query strings added `+' after `&' (to avoid browser translation).
2001-12-13: OEF now accepts \feedback. (Thanks to a suggestion of Jan Hlavacek.)
2001-12-12: Content selection in OEF intro page.
2001-12-11: oef2wims format now defaults to html (was tex). No effect on
		existing resources.
	    Auto math formatting available in oef2wims.
	    OEF exercises with no reply accepted.
2001-12-10: Popup help mode.
2001-12-09: Apache configuration automation with new aliases.
		WIMS can now be called outside user space.
	    RPM packaging starts to work (with home directory relocation).
	    Binary directories clean up.
2001-12-08: Configuration parameters cleaning up and online configuration.
2001-12-06: Document manager accepts file contents.
2001-12-05: File submission mechanism (for trusted modules).
2001-12-04: File permission check by site manager.
	    Request length limit quartupled (256K), for file submissions.
2001-12-02: WIMS document manager is ready.
2001-12-01: Added !defof.
2000-11-30: !item counting was wrong when first got item is empty.
	    Added !reinput. Createxo reinforced using !reinput.
2000-11-29: Site manager authorization for online site maintenance.
2000-11-28: Some more compatibility fixups in instex.
	    Added !detag.
2001-11-27: Forbidden user variables now silently ignored instead of
		generating user error (allow_violation).
	    Browsers are translating & strings when a text is put into a
		textarea. Createxo now corrects this (still partial).
2001-11-23: msg2wims was not in global makefile.
2001-11-18: Reorganization of front page.
	    Added default about page.
	    Instex was incompatible with Konqueror: use -coalesce
2001-11-11: Added site browsing module (en, fr).
2001-11-10: Module indexing protocol changed (more condensed).
	    More home search facilities.
2001-11-08: Search tool category in home page can also give popup forms.
---------------------------------------------
Version 3.01 packed.
2001-10-31: Facilities to recover lost exam session.
2001-10-27: public_html/scripts now holds files that can be called by any
	    module via !read.
---------------------------------------------
Version 3.00 packed.
2001-08-16: OEF manager added two options (allchoices and idontknow).
2001-08-15: home page lists added starting point.
2001-06-28: time bug: `now' was volatile!
---------------------------------------------
Version 2.45 packed. (Devel. version)
2001-06-25: Added `all module' search category.
2001-06-23: Code cleaning: fopen() -> accessfile() at many places.
2001-06-22: Fixups and enhancements in exam sheet management.
2001-06-20: Global score restriction in virtual classes.
	    Score time restriction in virtual classes.
	    Uniformize get-current-time in main program.
	    Typo: current score was not whown when exo number >10.
2001-06-18: Public work sheet database.
2001-06-17: Delete file in Modtool.
2001-06-15: Uniformized search engine from home page.
2001-06-12: Main program changes name (webmath -> wims).
2001-06-09: several call_sh() switched to call_ssh().
2001-06-07: Direct module indexer starts to work (w/o pgsql).
2001-06-02: Referencing error when wims.conf is missing.
	    Facility for automatic download of new distribution (wimsget).
2001-06-01: Several source configuration bugs.
	    Score counting change: prohibit simultaneous scoring. (This is not
	    100% compatible with earlier data due to parmreg.)
2001-05-30: gif_crop and chem-eq do not compile under new Linux. Removed from
            Makefile.
2001-05-28: added Modtool (online development of modules).
2001-05-10: WIMS can now also work behind https.
2001-05-01: Added configuration parameter gnuplot_format.
2001-04-21: OEF manager added equation reply type.
---------------------------------------------
Version 2.42 packed.
2001-04-02: reguser typo fixed.
2001-04-02: Added class_log() (security measure in virtual classes).
2001-03-31: All Wims popup windows are now chromeless (javascript).
2001-03-30: Security in virtual classes: one-time personal passwords.
	    Session closed when user quits the class.
	    (English and French versions only)
2001-03-24: Security in virtual classes: new user cannot use
	    account names where an erased user has worked.
2001-03-19: Popup operating mode allowing people to embed Wims tools into
	    their own web pages w/o installing the server.
2001-03-18: itemnum() counted wrong when first item is enclosed list.
2001-03-17: Students could see hidden sheets by directly typing url addresses.
	    !replace added keyword `internal'.
	    Popup windows are now focused using javascript.
	    Added !nonempty (lines or items).
2001-03-09: msg2wims was not compiling.
2001-03-08: variable reset bug in OEF manager (replytype).
---------------------------------------------
Version 2.41 packed.
2001-03-02: Virtual classes: ignore user scores with very low average.
2001-03-01: Spanish translation (kernel+douzen tools) by José Maria Sanchez.
2001-02-26: parameter blocking in virtual classes had corrupt variables.
2001-02-15: Typo in plot command of flydraw.
---------------------------------------------
Version 2.40 packed.
2001-02-06: Forum user registration email was sent to wrong address.
---------------------------------------------
Version 2.39 packed (internal).
2000-12-08: !translate added keyword `internal'.
2000-11-30: regclass starting (very unsufficient) anti-abuse feature.
2000-11-28: !text expand divided by 0 when mask is empty.
2000-11-24: Added some more TeX mathfonts (ldots, ddots, vdots).
2000-11-23: Corrected translator bug when one dictionary item is
	    subword of another.
2000-11-22: translator now accepts suffix translation (before main translation).
2000-11-21: search_list => segfault when table is empty.
2000-11-20: Added priority site configuration.
	    Encyclopedia now defaults to internal.
2000-11-14: Databases (dictionary, fortune) were omitted in the package.
---------------------------------------------
Version 2.37 packed.
2000-11-13: Source code location changed (ftp service closed by firewall).
2000-11-11: Added shortpath.c, computing shortest path linking given points.
2000-11-07: Reference to Maxima updated.
---------------------------------------------
Version 2.36 packed.
2000-11-07: Italian version added (thanks to Marina Cazzola).
2000-10-30: name substitution added in !exchange.
2000-10-03: pointer to Plouffe's inverter updated.
2000-09-10: !replace entered infinite loop when to-replace string is empty.
2000-09-05: fixing some bad references in virtual classes.
---------------------------------------------
Version 2.35 packed.
2000-08-28: exam structure in virtual classes.
2000-08-16: housekeep must use wrapexec.
2000-08-14: Modif to bin/{pari,povray}, to adapt to Ray 3D.
---------------------------------------------
Version 2.34 packed.
2000-06-13: Unable to find broken instex image bug, block (erase) it.
2000-06-11: Standardized href in exercises.
2000-06-08: bug in Pari interface: comments were not recognized.
	    added !listcomplement
2000-06-07: var.def accepts arrays.
---------------------------------------------
Version 2.32 packed.
2000-06-03: OEF modules now included in standard distribution.
	    addmodule bug introduced from adm/ modules reorganization.
	    psql modules field names protected by double quotes.
	    module log is disabled by default.
2000-05-29: Bug in forum user registration password check.
	    Online creation of message boards.
	    \special disabled in !instex.
2000-05-28: Interface to Octave.
	    Function name aliases were forgotten in Maxima interface.
2000-05-26: Virtual class score computation reorganization, adding manually
	    attributed scores (English and French versions).
2000-05-24: added !mailto (for trusted modules).
2000-05-23: isfinite() -> finite().
2000-05-21: added non-panicking internal_warn() method.
2000-05-19: Module log now creates directory tree.
---------------------------------------------
Version 2.30 packed.
2000-05-17: adm/ modules reorganization.
2000-05-14: Added message board to each class.
2000-05-12: Record 0 now allowed.
2000-05-09: Calls to system() are replaced by exec().
2000-05-06: added !insmath.
	   !rawmath no longer translates []{} into ()().
	   Improvements in rawmath() and texmath().
2000-05-04: Commas enclosed in parentheses are no longer item separators.
2000-05-02 Fixed problem with effective and real uid (for gnuplot).
	   session directory closed to other users.
2000-05-01 fix NAN comparison bug.
	   Eval name table unification (acceleration). getnum() replaced by strtod().
	   Flydraw added evalue, plot, linewidth, arrow, lattice, etc.
2000-04-26 fly replaced by flydraw.
2000-04-22 OEF manager accepts more reply types:
	   units, matrix, vector, set, formal.
	   units-filter by Georges Khaznadar.
2000-04-20 added !deaccent and !declosing.
---------------------------------------------
Version 2.23 packed.
2000-04-13 Partial compatibility effort with DOS 0D0A files.
	   subsession string accumulation: fixed.
2000-04-12 anti-cheating: random suspension of random generation of exercises.
	   Users are allowed to suspend score registration.
2000-04-10 `:' bug in scoring system fixed.
2000-04-04 added !msg.
---------------------------------------------
Version 2.20 packed.
2000-03-30 added class portal (adm/classes)
2000-03-25 General help pages.
	   Window size control for subsessions (javascript).
	   Powermarks is a bad browser.
2000-03-24 Score register was open for expired sheets (fixed).
2000-03-21 added variable wims_form_method.
	   Allows supervisor to change participant password by force.
2000-03-17 eCatch is a bad browser.
---------------------------------------------
Version 2.13 packed.
2000-03-11 added !reset. Change syntax of !exchange (added !exchange var1,var2).
2000-03-01 Classes: allow scores to be computed according to user formula.
---------------------------------------------
Version 2.12 packed.
2000-02-16 Forms now use post method to get around URI length limit.
2000-02-08 modifications in class management (move exercise in worksheet,
	   delete/modify class exercises).
---------------------------------------------
Version 2.11 packed.
2000-01-31 Allow class supervisors to erase exercises. (Modifs to createxo)
2000-01-27 added !texmath (linear math to tex source).
	   sec(x) and csc(x) admitted.
2000-01-19 cpu limit cut to half or 1/4 when the site is busy.
2000-01-17 Changed log rotation method, adding config variable old_log_files.
2000-01-16 Interface to Maxima.
---------------------------------------------
Version 2.10 packed.
2000-01-11 Fixed bug in module indexing program (multi-language priority).
	   Referer keepup during session.
2000-01-10 Mirror listing page prepared (but not open due to lack of mirrors).
2000-01-09 added !module.
2000-01-06 !shuffle added option even|odd.
2000-01-05 Partially disabled cache control for home module.
---------------------------------------------
Version 2.07 packed.
2000-01-03 added cache control lines.
1999-12-25 Source directory reorganized.
	   Added cyclicode (cyclic code generator).
	   Added !text interact and !text repeat.
---------------------------------------------
Version 2.05 packed.
1999-12-23 Simplified Chinese version officially open.
	   Translators: team in ECNU lead by CHEN Zhijie.
---------------------------------------------
Version 2.04 packed.
1999-12-13 Bug in wordchr, itemchr, linechr causing crash when
	   searched-for string is empty. Fixed.
1999-12-10 Parameter passing under !read (wims_read_parm).
1999-12-06 Change to html/auth.phtml.*
1999-12-05 interface program sources relocated.
1999-12-03 More adm modules in Chinese.
1999-12-01 A private .htaccess file was not deleted in the public distribution.
---------------------------------------------
Version 2.03 packed.
1999-11-29 Some adm files and modules in Chinese incorporated.
1999-11-17 Interface to GAP.
1999-11-11 Expiration management takes cgi_name into account.
	   add site_description and site_keywords to wims.conf.
1999-11-08 Important bug fix: a process number limit (rlimit_nproc) of 32
	   was much too small. Lifted to 512.
---------------------------------------------
Version 2.01 packed.
1999-11-05 Delete participant and hide sheets by supervisor.
	   Password change facilities.
1999-11-03 Regclass: email address check reinforced.
1999-11-01 Intelligent determination of module according to cgi_name.
1999-10-30 public phtml files reorganized.
---------------------------------------------
Version 2.00 packed.
1999-10-28 Session names lifted to 10 characters, to ensure uniqueness.
1999-10-26 Subsessions now have different appearance.
1999-10-24 Class structure reorganized: sql is no longer used for it.
1999-10-23 Unified PATH setup through wims.conf.
1999-10-17 Function log10(x) added to Pari and Mupad interfaces.
---------------------------------------------
Version 1.55 packed.
1999-10-03 cmd=help should not write to last.html. Corrected.
1999-09-30 robot trapper also works for expired sessions.
---------------------------------------------
Version 1.53 packed.
1999-09-26 bad agent reorganization.
1999-09-24 added a robot trapper to the system.
	   Logo bug fixed.
1999-09-23 MemoWeb is a very bad user agent.
1999-09-20 bug fix in calls to output(): `%' was sometimes interpreted.
1999-09-18 stat module acceleration and language detection.
---------------------------------------------
Version 1.50 packed.
1999-09-06 minor touches in variable passing mechanism (security features).
1999-09-04 Detail of individual user work added into class supervisor facilities.
	   added worksheet source management.
1999-09-02 Robot access management bugfix and more restrictions.
1999-08-29 added dictionary-translator as an exec program.
1999-08-28 module searching engine is working.
1999-08-26 caching sql for acceleration. module_init_parm bug fix.
---------------------------------------------
Version 1.35 packed.
1999-08-23 added some big parentheses to mathfont.
1999-08-21 added $wims_intro_parm (to be managed by the module).
1999-08-15 added !exchange.
1999-08-12 added !rawmatrix.
---------------------------------------------
Version 1.34 packed.
1999-08-08 HTTrack is a very bad user agent.
1999-08-05 added illegal module change detection (often in robot accesses).
1999-08-04 session management overhaul: subsession, serial.
---------------------------------------------
Version 1.33 packed.
1999-08-02 added factorial evaluation to evalue().
1999-08-01 module indexing speedup. More national flags.
1999-07-23 misc bug fixes for compatibility with RedHat 6.0.
1999-07-03 Mupad interface `!' char checking bug fix.
1999-07-02 Pointer to Eric's Treasure Troves changed.
---------------------------------------------
Version 1.32 packed.
1999-06-25 oef translator accepts analyzed answers (numerical only).
1999-06-24 varchr() modified (add underscore detection)
1999-06-23 !pari about, !mupad about, with all module about.phtml changed.
1999-06-22 $pari_header_2...$pari_header_8, same for mupad.
1999-06-16 getvar() bugfix (empty name)
---------------------------------------------
Version 1.30 packed.
1999-06-15 added !debug.
1999-06-13 bugfix in itemchr().
1999-06-12 added !positionof.
	log file was occasionally overwritten when simultaneous access
	occurs while it is being renamed.
1999-06-11 islineof, notlineof in !if.
1999-06-09 pari and mupad interface security enhancement (illegal keywords).
1999-06-08 !replace enhancement: word, item, line replacement.
1999-06-07 added variable ins_out.
1999-06-04 line counting bug in open_workfile().
---------------------------------------------
Version 1.25 packed.
1999-05-29 float2str() acceleration for integers.
1999-05-25 Preliminary interface to octave.
1999-05-22 Programs called by !exec and !mexec can now set return variables
	(by writing to $session_dir/exec.var)
1999-05-18 added !distribute.
1999-05-10 added !text, with a first batch of commands. Doc updated accordingly.
1999-05-09 Changed file reading method (speed optimization).
1999-04-27 adaptation of pari/gp interface for 2.0.14 (goodbyestring)
---------------------------------------------
Version 1.24 packed.
1999-04-23 added parameter $pari_header and $mupad_header
	space characters in query string are thrown away. (currently useless)
1999-04-22 Bug fix in substit() when string terminates with a $.
---------------------------------------------
Version 1.23 packed.
1999-04-04 Added !singlespace, !nospace, !lines2words...,
	!listintersect, !listunion, !listuniq.
	Multiple-output of executions are now controled by the file exec.type.
1999-02-16 Added $wims_exec_out_2...
---------------------------------------------
Version 1.21 packed.
1999-01-27 Bug fix in evalue (|x| version of absolute value)
---------------------------------------------
Version 1.20 packed.
1998-12-29 Selective score registration mecanism for registered users.
1998-12-28 Adding 2-parm functions to evalue().
1998-12-27 evalue() adopts more strict syntax check.
1998-12-25 oef creator starts to work.
	Worksheet was lost when the exercise is renewed.
1998-12-21 comparison added isitemof and notitemof.
	oef manager starts to work.
1998-12-14 Users are prohibited to enter raw $ signs (will be replaced by &#36;).
	!varlist adds a switch ``nofn''.
1998-12-13 |x| now recognized by !rawmath (and replaced by abs(x)).
1998-12-12 fixing a score delay bug/misfeature in bottom reference box.
	all sscanf() replaced by atof, atoi.
---------------------------------------------
Version 1.17 packed.
1998-12-10 added !sort.
	Bugfix in simultaneous request prohibition: incompatibility with getframe.
---------------------------------------------
Version 1.16 packed.
1998-12-07 Bugfix in simultaneous request prohibition.
	Bugfix in evalue() (exponential number).
---------------------------------------------
Version 1.15 packed.
1998-12-05 Simultaneous request prohibited (user_error).
	Unmatched_parentheses now allows the user to correct the error.
1998-12-04 User parentheses check reinforced to all 3 kinds (), {}, []
	Server load control: requests refused when thresholds exceeded.
1998-12-03 User error message file now in phtml format.
1998-12-02 !translate no longer calls tr when only simple translations.
---------------------------------------------
Version 1.14 packed.
1998-11-30 !replace no longer calls sed when there is no regexp. (acceleration)
1998-11-26 added !bound.
1998-11-23 added !formselect, !formradio, !formbar. Doc updated.
	Modules will be progressively changed to use them.
---------------------------------------------
Version 1.13 packed.
1998-11-21 added good browser `HtmlViewer'.
1998-11-20 Bug fix in client charset determination (intro pages).
	First language in configure file's site_languages is now default.
---------------------------------------------
Version 1.12 packed.
1998-11-16 Minor bug fixes in sheet preparation for supervisor.
1998-11-15 Fix a typo in mathname_split() which created infinite loop.
	!insplot sets a variable ins_animation (yes no).
	Added $wims_warn_rawmath_parm.
1998-11-12 Variable wims_main_font, defining client charset.
1998-11-06 More options in usage statistics.
---------------------------------------------
Version 1.11 packed.
1998-11-03 More optimization in _skip_if_contents().
	Animation in !insplot is now using convert. gifmerge is no longer used
	(incompatibility with gd 1.3).
	Added definitions `translator' and `translator_address' in modules'
	INDEX files.
1998-11-02 Module log disabled for robot access.
	Start multilanguage support: configuration variable site_languages
	and wims variable $wims_site_languages.
	Site languages can be defined in wims.conf.
---------------------------------------------
Version 1.10 packed.
1998-10-31 added !header, !title and !tail, to standardize html format.
	Doc and most modules updated accordingly.
1998-10-30 automatic detection of other languages for light pages.
1998-10-29 added !headmenu, for header menu bar. All modules updated accordingly.
	added variable wims_ref_bgcolor, configurable.
1998-10-28 New visitors' home page, refering to two pages in adm/light (new, bestof).
	bug fix in !mexec.
1998-10-26 slight modif of adm/stat, file plotdata.sh (last plotting point)
1998-10-25 slight reorg of insplot
---------------------------------------------
Version 1.06 packed (misc. bug fix).
1998-10-18 cmd_output_too_long is now user_error.
---------------------------------------------
Version 1.05 packed.
1998-10-13 added OmniWeb to the list of recognized browsers.
---------------------------------------------
Version 1.04 packed.
1998-09-16 log column in var.def is now optional (defaults to 0).
---------------------------------------------
Version 1.03 packed.
1998-09-13 added a new command !varlist.
1998-09-10 Bug fix in evaluation (it gave -3^2=9)
---------------------------------------------
Version 1.02 packed 1998-09-08 (misc. modif.)
Version 1.01 packed (misc. bug fix).
Version 1.00 packed.
1998-08-23 added system for messages of the day.
1998-08-18 user scoring system starts to work.
1998-08-14 class, sheet, exo: first working structure.
---------------------------------------------
Version 0.17.4 packed.
1998-08-09 ready to accept creation of class and registration of participants.
1998-08-09 added ins_warn=fail when dynamic insertion fails.
---------------------------------------------
Version 0.17.3 packed (emergency bug fix).
Version 0.17.2 packed.
1998-08-04 User/supervisor authentification started.
1998-08-03 added !sql (administrative use only).
1998-08-01 Module database starts to work.
---------------------------------------------
Version 0.17.1 packed.
Version 0.16.4 packed.
1998-07-19 Request w/o command: now go to intro or new, depending on
	the existence of intro.phtml.
	   added module_init_parm.
---------------------------------------------
Version 0.16.3 packed.
1998-07-17 referer log fixup: links pointing to intro were not counted.
1998-07-09 cotangent function now recognized at all levels.
	   line length increased to 16K.
---------------------------------------------
Version 0.16.2 packed (minor bug fix).
Version 0.16.1 packed.
1998-06-30. added multiplot support in insplot..processor.
---------------------------------------------
Version 0.15.11 packed.
1998-06-15. added backward link list.
---------------------------------------------
Version 0.15.10 packed.
1998-06-13. uniformed treatment of page expiration. (escape var: wims_expire)
1998-06-12. added automatic recognition of robot accesses.
----------------------------------------------
Version 0.15.9 packed (emergency bug fix).
Version 0.15.8 packed (minor fixes).
----------------------------------------------
Version 0.15.7 packed.
1998-06-09. bug correction in module_log().
	    added bookmark indication to homeref.
----------------------------------------------
Version 0.15.6 packed.
1998-06-07. predetermine_language also looks at user agent language.
1998-06-06. added referer log.
1998-06-05. default language is now English.
	    corrected error log methods.
----------------------------------------------
Version 0.15.5 packed.
1998-06-03. Home module is now always expired (it cannot allow cache)
	    added automatic determination of module language extension.
----------------------------------------------
Version 0.15.4 packed.
1998-06-01. Home is now a module.
1998-05-31. log and account includes all clicks.
	    improvements to stat module.
----------------------------------------------
Version 0.15.3 packed.
1998-05-23. TeX inserts now have border cut. Alignment problems disappear.
	    Misc tex bugs.
1998-05-21. added statistics module.
----------------------------------------------
Version 0.15.2 packed.
1998-05-17. bug fix: ref_base.
1998-05-15. log method modified. (now appending)
1998-05-13. Access accounting started. (Via cron)
----------------------------------------------
Version 0.15.1 packed (misc bug fixes).
----------------------------------------------
Version 0.14.1 packed.
1998-05-04. !href target bug corrected.
----------------------------------------------
Version 0.14 packed.
1998-05-02. Warning structure established (via !warn and $wims_warn_...)
	    !insplot: patch of gnuplot integer arithmetic problem.
	    !htmlmath improvement.
1998-05-01. rawmath routine rewritten.
1998-04-30. A very simple interface for Plouffe's Inverter.
1998-04-27. added commands !filewrite and !fileappend.
----------------------------------------------
Version 0.13.3 packed.
1998-04-13. added command !append.
1998-04-12. added user options: language and texsize.
	    texsize can also be changed within modules (via $wims_texsize).
----------------------------------------------
Version 0.13.2 packed.
1998-04-07. bug correction on session creation when old session expired.
	    added listfile (privileged command)
----------------------------------------------
Version 0.13.1 packed.
1998-04-06. replace and translate secured (using env parms).
1998-03-31. i will now be interpreted by pari and mupad as I.
----------------------------------------------
Version 0.12 packed.
1998-03-29. session cleaning reorganisation: more clever.
1998-03-27. wims logo created.
----------------------------------------------
Version 0.11.7 packed.
1998-03-27. tex size starts to be configurable.
	    instexst no longuer drops files into module's homes.
1998-03-24. added mathsubst and evalsubst
1998-03-21. added iswordof, isvarof in !if.
1998-03-20. Insplot is now animated.
1998-03-19. TeX, mathfont and insplot: misc. improvements.
----------------------------------------------
Version 0.11.6 packed.
1998-03-18. eval() now knows and outputs NaN and Inf.
	    added htmlmath (preliminary version).
1998-03-17. added module_about structure.
	    added math fonts structure. (variables starting with m_ )
-----------------------------------------------
Version 0.11.5 packed.
1998-03-14. server now reads module's INDEX file, storing definitions
	    into module_... variables.
	    added wims_html_header.
	    Tests also existence of intro.phtml, help.phtml, etc.
	    !instexst filename is now optional, and !instex calls it whenever possible.
	    !form now accepts optional cmd value.
1998-03-13. subst_limit increased from 36 to 3000.
            added !homeref.
1998-03-10. added encyclopedia pointer.
-----------------------------------------------
Version 0.11.4 packed.
1998-03-09. user variables. if module defined and cmd not: set cmd=new.
	    Expired sessions send directly to wims homepage.
1998-03-08. patches to MuPAD TeX output bugs and incompatibilities.
1998-03-07. change evaluation order: 3/5*2 is now left-associative, as other softwares.
1998-03-05. added randitem, randword, ...
-----------------------------------------------
Version 0.11.2 packed.
1998-02-21. added httpd_ variables. Doc updated accordingly.
1998-02-21. added rawmath common error correction.
------------------------------------------------
Version 0.11.1 packed.
1998-02-20. added general_log_limit and user_agent log.
1998-02-19. added ins_align and wims_version_date. No subst for !href.
1998-02-18. added cleansessions call (to be used via cron)
1998-02-17. template modules reorganisation.
1998-02-17. !instexst now works in intro.phtml
	(not very correctly: using $HOME/tmp for temporary directory.)
-----------------------------------------------
1998-02-12. First version (0.10) packed.

